!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!  21 January 2010                                         !!
!!                     Change Size                          !!
!!                    Post-Procesing                        !!
!!                                                          !!
!!                                        version 1.21_0.10 !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
MODULE new_sizes

  INTEGER                     :: mx, my, mz, ccx, ccy, ccz, rrx, rry, rrz
  INTEGER(8)                  :: plan_new_RtoC
  INTEGER                     :: local_nzB, local_z_startB
  INTEGER                     :: local_ny_after_transposeB, local_y_start_after_transposeB, local_nrB
  INTEGER, ALLOCATABLE, DIMENSION (:)    ::  nodeyB, ystartB, ysizeB

END MODULE new_sizes



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                           chsize                         !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

PROGRAM pp_chsize
  USE parameters
  USE new_sizes
  USE mpi_var
  USE fftwmodule
  IMPLICIT NONE  
  
  COMPLEX, ALLOCATABLE, DIMENSION (:,:,:,:)      :: old_vel, new_vel, old_mag, new_mag, old_scal, new_scal
  INTEGER, ALLOCATABLE, DIMENSION (:,:)          :: temp2
  INTEGER, ALLOCATABLE, DIMENSION (:)            :: temp
  INTEGER                     :: udx, udy, udz, qx, qy, qz, qqy, rc, mhd
  INTEGER                     :: n_dim(3)
  CHARACTER(LEN=namelength)   :: new_simname
  CHARACTER(LEN=2)            :: csc 
  INTEGER                     :: new_nfields, new_totpart, iscal
  
  NAMELIST /type_of_equations/ VELEQ, MAGEQ, NSCAL
  NAMELIST /old_files/ nx, ny, nz, lx, ly, lz, simname, nfields, totpart
  NAMELIST /new_files/ mx, my, mz, new_simname, new_nfields, new_totpart

  
  CALL MPI_INIT( ierr )
  CALL MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
  CALL MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Read and broadcast the parameters for the input fields...
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   IF (myid.eq.ioid) THEN
    OPEN(10,FILE='chsize.par',STATUS='OLD',FORM='FORMATTED')
    READ(unit=10,NML=type_of_equations)
    CLOSE(10)
    IF (NSCAL>0) THEN 
      SCAEQ=.TRUE.
    ELSE
      SCAEQ=.FALSE.
    END IF
    IF (VELEQ) THEN 
      WRITE(6,*) 'Velocity field : YES'
    ELSE
      WRITE(6,*) 'Velocity field : NO'
    END IF
    IF (MAGEQ) THEN 
      WRITE(6,*) 'Magnetic field : YES'
    ELSE
      WRITE(6,*) 'Magnetic field : NO'
    END IF
    WRITE(6,*) 'Scalar field(s) : ', NSCAL
  END IF
  
  CALL MPI_BCAST(VELEQ,1,MPI_LOGICAL,ioid,MPI_COMM_WORLD,ierr)
  CALL MPI_BCAST(MAGEQ,1,MPI_LOGICAL,ioid,MPI_COMM_WORLD,ierr)
  CALL MPI_BCAST(SCAEQ,1,MPI_LOGICAL,ioid,MPI_COMM_WORLD,ierr)
  CALL MPI_BCAST(NSCAL,1,MPI_INTEGER,ioid,MPI_COMM_WORLD,ierr)

  IF (myid.eq.ioid) THEN
    OPEN(10,FILE='chsize.par',STATUS='OLD',FORM='FORMATTED')
    READ(unit=10,NML=old_files)
    CLOSE(10)
    WRITE(6,*) 'OLD FILES PARAMETERS '
    WRITE(6,'(A30, I8, A3, I8, A3, I8)')  'Number of points are ', nx,'x',ny,'x',nz
    WRITE(6,'(A30, F8.4,A3,F8.4,A3,F8.4)') 'Box sizes / pi are   ', lx,'x',ly,'x',lz
    lx=lx*pi
    ly=ly*pi
    lz=lz*pi
    WRITE(6,*) 'simulation name ', simname
    WRITE(6,*) 'number of fields that will be read', nfields
    WRITE(6,*) 'totpart', totpart
  END IF
  
  CALL MPI_BCAST(nx,1,MPI_INTEGER,ioid,MPI_COMM_WORLD,ierr)
  CALL MPI_BCAST(ny,1,MPI_INTEGER,ioid,MPI_COMM_WORLD,ierr)
  CALL MPI_BCAST(nz,1,MPI_INTEGER,ioid,MPI_COMM_WORLD,ierr)
  CALL MPI_BCAST(lx,1,MPI_MYREAL,ioid,MPI_COMM_WORLD,ierr)
  CALL MPI_BCAST(ly,1,MPI_MYREAL,ioid,MPI_COMM_WORLD,ierr)
  CALL MPI_BCAST(lz,1,MPI_MYREAL,ioid,MPI_COMM_WORLD,ierr)
 ! CALL MPI_BCAST(simname,namelength,MPI_CHARACTER,ioid,MPI_COMM_WORLD,ierr)
  CALL MPI_BCAST(nfields,1,MPI_INTEGER,ioid,MPI_COMM_WORLD,ierr)
  CALL MPI_BCAST(totpart,1,MPI_INTEGER,ioid,MPI_COMM_WORLD,ierr)  

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Initialize all the dimensions and local y/z parameters used by the
!!! MPI version of FFTW with old dimensions nx, ny, nz
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  CALL init_fft3d()

  ALLOCATE(ystart(0:numprocs-1), ysize(0:numprocs-1))
  ALLOCATE(temp(0:numprocs-1))
  temp=0
  temp(myid)=local_y_start_after_transpose
  CALL mpi_allreduce(temp,ystart,numprocs,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,ierr) 
  temp=0
  temp(myid)=local_ny_after_transpose
  CALL mpi_allreduce(temp,ysize,numprocs,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,ierr) 
  DEALLOCATE(temp)

  ALLOCATE(nodey(0:ny-1))
  ALLOCATE(temp(0:ny-1))
  temp=0
  DO qy=0,cy
    qqy=qy+local_y_start_after_transpose
    temp(qqy)=myid
  END DO
  CALL mpi_allreduce(temp,nodey,ny,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,ierr) 
  DEALLOCATE(temp)
  
  IF (myid.eq.ioid)  WRITE(6,'(A50, I6, A3, I6, A3, I6)')  'FFTW/MPI initialized for dimensions', nx,'x',ny,'x',nz

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! initialize the wavevectors (necessary for the readfile) with 
!!! old dimensions nx, ny, nz
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  ALLOCATE(kx(0:cx), ky(0:cy), kz(0:cz))
  DO qx=0,nx/2
    kx(qx)=twopi*qx/lx
  END DO
  DO qz=0,nz/2
    kz(qz)=twopi*qz/lz
  END DO
  DO qz=nz/2+1,nz-1
    kz(qz)=twopi*(qz-nz)/lz
  END DO
  DO qy=0,cy
    qqy=qy+local_y_start_after_transpose
    IF (qqy.le.ny/2)  ky(qy)=twopi*(qqy)/ly
    IF (qqy.gt.ny/2)  ky(qy)=twopi*(qqy-ny)/ly
  END DO

  ALLOCATE(whereis_ky(0:ny-1,2),temp2(0:ny-1,2))
  temp2=0
  DO qy=0,cy
    qqy=qy+local_y_start_after_transpose
    temp2(qqy,1)=myid
    temp2(qqy,2)=qy
  END DO
  CALL mpi_allreduce(temp2,whereis_ky,2*ny,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,ierr) 
  DEALLOCATE(temp2)

  IF (myid.eq.ioid)  WRITE (6,*) 'Wavevectors initialized for dimensions', nx, ny, nz

  IF (myid.eq.ioid) THEN
    OPEN(10,FILE='chsize.par',STATUS='OLD',FORM='FORMATTED')
    READ(unit=10,NML=new_files)
    CLOSE(10)
    WRITE(6,*) '  '
    WRITE(6,*) 'NEW FILES PARAMETERS '
    WRITE(6,'(A30, I8, A3, I8, A3, I8)')  'Number of points are ', mx,'x',my,'x',mz
    WRITE(6,*) 'simulation name ', new_simname
    WRITE(6,*) 'number of fields that will be saved', new_nfields
    WRITE(6,*) 'totpart', new_totpart
  END IF

  CALL MPI_BCAST(mx,1,MPI_INTEGER,ioid,MPI_COMM_WORLD,ierr)
  CALL MPI_BCAST(my,1,MPI_INTEGER,ioid,MPI_COMM_WORLD,ierr)
  CALL MPI_BCAST(mz,1,MPI_INTEGER,ioid,MPI_COMM_WORLD,ierr)
!  CALL MPI_BCAST(new_simname,namelength,MPI_CHARACTER,ioid,MPI_COMM_WORLD,ierr)
  CALL MPI_BCAST(new_nfields,1,MPI_INTEGER,ioid,MPI_COMM_WORLD,ierr)
  CALL MPI_BCAST(new_totpart,1,MPI_INTEGER,ioid,MPI_COMM_WORLD,ierr)  

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! read old fields to be transformed
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
  IF (VELEQ) THEN
    ALLOCATE(old_vel(0:cx,0:cz,0:cy,3))
    CALL read_vec_divfree(old_vel,simname//'_u')
  END IF

  IF (MAGEQ) THEN
    ALLOCATE(old_mag(0:cx,0:cz,0:cy,3))
    CALL read_vec_divfree(old_mag,simname//'_b')
  END IF

  IF (SCAEQ) THEN
     ALLOCATE(old_scal(0:cx,0:cz,0:cy,NSCAL))
     DO iscal=1,NSCAL
       WRITE(csc,'(i2.2)') iscal
       CALL read_scal(old_scal(:,:,:,iscal),simname//'_s'//csc//'.')
     END DO
  END IF

  IF (myid.eq.ioid)  WRITE (6,*) 'Input fields have been read.'

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! just check if the sizes make sense...
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  udx = 0
  udy = 0
  udz = 0
  
  IF (mx.lt.nx) udx=1 
  IF (my.lt.ny) udy=1 
  IF (mz.lt.nz) udz=1 

  IF (mx.gt.nx) udx=2 
  IF (my.gt.ny) udy=2 
  IF (mz.gt.nz) udz=2 
  
  IF ((udx.ne.udy).or.(udx.ne.udz)) THEN
    IF (myid.eq.ioid) THEN
      WRITE(6,*) 'ERROR : compress in one direction and expand'
      WRITE(6,*) 'in another direction at the same time is not implemented yet'
    END IF
    CALL MPI_FINALIZE(rc)
  END IF

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Initialize all the dimensions and local y/z parameters used by the
!!! MPI version of FFTW with new dimensions mx, my, mz
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  n_dim(1)=mx; n_dim(2)=my; n_dim(3)=mz
  CALL rfftwnd_f77_mpi_create_plan(plan_new_RtoC,MPI_COMM_WORLD, 3, n_dim,FFTW_REAL_TO_COMPLEX,FFTW_ESTIMATE)
  CALL rfftwnd_f77_mpi_local_sizes(plan_new_RtoC,local_nzB,local_z_startB,&
                                   local_ny_after_transposeB,local_y_start_after_transposeB,local_nrB)
                                   
  ccx=mx/2
  ccy=local_ny_after_transposeB-1
  ccz=mz-1
  rrx=mx+1
  rry=my-1
  rrz=local_nzB-1
  IF ((ccy+1)*(ccz+1).ne.(rry+1)*(rrz+1)) THEN
    WRITE(6,*) 'This code assumes that on each node the product of the last'
    WRITE(6,*) 'two dimensions of real and complex fields are the same. This'
    WRITE(6,*) 'is not achievable with the choice my=', my,', mz=', mz,' and ', numprocs,' processors.'
    WRITE(6,*) 'Please retry with another number of processors.'
    STOP    
  END IF

  ALLOCATE(ystartB(0:numprocs-1), ysizeB(0:numprocs-1))
  ALLOCATE(temp(0:numprocs-1))
  temp=0
  temp(myid)=local_y_start_after_transposeB
  CALL mpi_allreduce(temp,ystartB,numprocs,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,ierr) 
  temp=0
  temp(myid)=local_ny_after_transposeB
  CALL mpi_allreduce(temp,ysizeB,numprocs,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,ierr) 
  DEALLOCATE(temp)
  
  ALLOCATE(nodeyB(0:my-1))
  ALLOCATE(temp(0:my-1))
  temp=0
  DO qy=0,ccy
    qqy=qy+local_y_start_after_transposeB
    temp(qqy)=myid
  END DO
  CALL mpi_allreduce(temp,nodeyB,my,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,ierr) 
  DEALLOCATE(temp)
  
 IF (myid.eq.ioid)  WRITE(6,'(A50, I6, A3, I6, A3, I6)')  'FFTW/MPI initialized for dimensions', mx,'x',my,'x',mz

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! Make the expansion or compression or duplicate depending on the parameters.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  IF (VELEQ) ALLOCATE(new_vel(0:ccx,0:ccz,0:ccy,3))
  IF (MAGEQ) ALLOCATE(new_mag(0:ccx,0:ccz,0:ccy,3))
  IF (SCAEQ) ALLOCATE(new_scal(0:ccx,0:ccz,0:ccy,NSCAL))

  SELECT CASE (udx)
    CASE(0)
      IF (myid.eq.ioid)  WRITE(*,*) 'Dimension are identical : I will duplicate without modifying the file.'
      IF (VELEQ) new_vel=old_vel
      IF (MAGEQ) new_mag=old_mag
      IF (SCAEQ) new_scal=old_scal
      IF (myid.eq.ioid)  WRITE(*,*) 'END OF DUPLICATE'
     
    CASE(1)
      IF (myid.eq.ioid)  WRITE(*,*) 'COMPRESSION'
      IF (VELEQ) CALL multiple_compress(3,old_vel,new_vel)
      IF (MAGEQ) CALL multiple_compress(3,old_mag,new_mag)
      IF (SCAEQ) CALL multiple_compress(NSCAL,old_scal,new_scal)
      IF (myid.eq.ioid)  WRITE(*,*) 'END OF COMPRESSION'
 
    CASE(2)
      IF (myid.eq.ioid)  WRITE(*,*) 'EXPANSION'
       IF (VELEQ) CALL multiple_expand(3,old_vel,new_vel)
       IF (MAGEQ) CALL multiple_expand(3,old_mag,new_mag)
       IF (SCAEQ) CALL multiple_expand(NSCAL,old_scal,new_scal)
       IF (myid.eq.ioid)  WRITE(*,*) 'END OF EXPANSION'
 END SELECT

  DEALLOCATE(kx,ky,kz)
  DEALLOCATE(ysize,ystart,nodey)
  DEALLOCATE(ysizeB,ystartB,nodeyB)
  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! initialize the wavevectors of the ouput dimensions (necessary to write fields)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  nx=mx
  ny=my
  nz=mz
  
  CALL init_fft3d()
  
  ALLOCATE(ystart(0:numprocs-1), ysize(0:numprocs-1))
  ALLOCATE(temp(0:numprocs-1))
  temp=0
  temp(myid)=local_y_start_after_transpose
  CALL mpi_allreduce(temp,ystart,numprocs,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,ierr) 
  temp=0
  temp(myid)=local_ny_after_transpose
  CALL mpi_allreduce(temp,ysize,numprocs,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,ierr) 
  DEALLOCATE(temp)
  
  ALLOCATE(kx(0:cx), ky(0:cy), kz(0:cz))
  DO qx=0,nx/2
    kx(qx)=twopi*qx/lx
  END DO
  DO qz=0,nz/2
    kz(qz)=twopi*qz/lz
  END DO
  DO qz=nz/2+1,nz-1
    kz(qz)=twopi*(qz-nz)/lz
  END DO
  DO qy=0,cy
    qqy=qy+local_y_start_after_transpose
    IF (qqy.le.ny/2)  ky(qy)=twopi*(qqy)/ly
    IF (qqy.gt.ny/2)  ky(qy)=twopi*(qqy-ny)/ly
  END DO

  DEALLOCATE(whereis_ky)
  ALLOCATE(whereis_ky(0:ny-1,2),temp2(0:ny-1,2))
  temp2=0
  DO qy=0,cy
    qqy=qy+local_y_start_after_transpose
    temp2(qqy,1)=myid
    temp2(qqy,2)=qy
  END DO
  CALL mpi_allreduce(temp2,whereis_ky,2*ny,MPI_INTEGER,MPI_SUM,MPI_COMM_WORLD,ierr) 
  DEALLOCATE(temp2)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! put the n/2 mode to zero and write output fields
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
  nfields=new_nfields
  totpart=new_totpart
  
  IF (VELEQ) THEN
    new_vel(nx/2,:,:,:)=0.
    new_vel(:,nz/2,:,:)=0.
    DO qy= 0, cy
      IF (ABS(ky(qy)-twopi*ny/ly/2).lt.EPS)  new_vel(:,:,qy,:)=0.
    END DO
    CALL write_vec_divfree(new_vel,new_simname//'_u')
  END IF

  IF (MAGEQ) THEN
    new_mag(nx/2,:,:,:)=0.
    new_mag(:,nz/2,:,:)=0.
    DO qy= 0, cy
      IF (ABS(ky(qy)-twopi*ny/ly/2).lt.EPS)  new_mag(:,:,qy,:)=0.
    END DO
    CALL write_vec_divfree(new_mag,new_simname//'_b')
  END IF

  IF (SCAEQ) THEN
    new_scal(nx/2,:,:,:)=0.
    new_scal(:,nz/2,:,:)=0.
    DO qy= 0, cy
      IF (ABS(ky(qy)-twopi*ny/ly/2).lt.EPS)  new_scal(:,:,qy,:)=0.
    END DO
     DO iscal=1,NSCAL
       WRITE(csc,'(i2.2)') iscal
       CALL write_scal(new_scal(:,:,:,iscal),new_simname//'_s'//csc//'.')
     END DO
  END IF

   IF (myid.eq.ioid)  WRITE (6,*) 'Output fields have been written'

  DEALLOCATE(kx,ky,kz)
  DEALLOCATE(ysize,ystart)
    
  CALL MPI_FINALIZE(rc)

END PROGRAM pp_chsize

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                          expand                          !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
SUBROUTINE expand(f_small,f_big)        
      
  USE parameters
  USE new_sizes
  USE mpi_var
  IMPLICIT NONE

  COMPLEX, INTENT(IN), DIMENSION(0:cx,0:cz,0:cy)      :: f_small
  COMPLEX, INTENT(OUT), DIMENSION(0:ccx,0:ccz,0:ccy)  :: f_big
  COMPLEX, ALLOCATABLE, DIMENSION(:,:)  :: ftemp_send, ftemp_recv
  INTEGER :: qy_small, qy_big, qy_send, qy_recv, receiver, sender, totsizec 
  REAL    :: fac

  fac=(1.0*mx/nx)*(1.0*my/ny)*(1.0*mz/nz)
  f_big=0.0
  totsizec=(nx/2+1)*nz
  ALLOCATE(ftemp_send(0:nx/2,0:nz-1),ftemp_recv(0:nx/2,0:nz-1))
  CALL MPI_BARRIER(MPI_COMM_WORLD,ierr)
  
  DO qy_small = 0, ny-1
    sender   = nodey(qy_small)
    IF (qy_small.le.ny/2-1) qy_big=qy_small
    IF (qy_small.ge.ny/2)   qy_big=my-ny+qy_small
    receiver = nodeyB(qy_big)
    
    IF ((myid.eq.sender).and.(sender.eq.receiver)) THEN
      qy_send=qy_small- ystart(sender)
      qy_recv=qy_big  - ystartB(receiver)
      f_big(0:nx/2 , 0:nz/2-1     , qy_recv) = f_small(: , 0:nz/2-1 , qy_send)
      f_big(0:nx/2 , mz-nz/2:mz-1 , qy_recv) = f_small(: , nz/2:nz-1, qy_send)
    END IF
    
    IF ((myid.eq.sender).and.(sender.ne.receiver)) THEN 
      qy_send=qy_small- ystart(sender)
      ftemp_send=f_small(:,:,qy_send)
      CALL MPI_SEND(ftemp_send,totsizec,MPI_MYCOMPLEX,receiver,10,MPI_COMM_WORLD,ierr)
    END IF
    
    IF ((myid.eq.receiver).and.(sender.ne.receiver)) THEN
      CALL MPI_RECV(ftemp_recv,totsizec,MPI_MYCOMPLEX,sender,10,MPI_COMM_WORLD,status_mpi,ierr)
      qy_recv=qy_big  - ystartB(receiver)
      f_big(0:nx/2 , 0:nz/2-1     , qy_recv) = ftemp_recv(: , 0:nz/2-1 )
      f_big(0:nx/2 , mz-nz/2:mz-1 , qy_recv) = ftemp_recv(: , nz/2:nz-1)
    END IF
    
    CALL MPI_BARRIER(MPI_COMM_WORLD,ierr)
  END DO
  
  f_big=f_big*fac

  DEALLOCATE(ftemp_send,ftemp_recv)

END SUBROUTINE expand

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                         compress                         !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

SUBROUTINE compress(f_big,f_small)     

  USE parameters
  USE new_sizes
  USE mpi_var
  IMPLICIT NONE
  
  COMPLEX, INTENT(IN)    :: f_big(0:cx,0:cz,0:cy)
  COMPLEX, INTENT(OUT)   :: f_small(0:ccx,0:ccz,0:ccy)
  REAL                   :: fac
  COMPLEX, ALLOCATABLE, DIMENSION(:,:)  :: ftemp_send, ftemp_recv
  INTEGER :: totsizec, qqy, qy, rqy, receiver, sender, qy_recv

  fac=(1.0*nx/mx)*(1.0*ny/my)*(1.0*nz/mz)
  
  f_small=0.0

  totsizec=(nx/2+1)*nz

  ALLOCATE(ftemp_send(0:nx/2,0:nz-1),ftemp_recv(0:nx/2,0:nz-1))
  
  DO qqy = 0, ny/2
    sender = nodeyB(qqy)
    receiver=nodey(qqy)
!    write(*,*) 'compress : qqy=',qqy, '    sender = ', sender, '   receiver =', receiver
    qy=qqy-ystartB(sender)
    IF (myid.eq.sender) THEN
      ftemp_send(: , 0:nz/2-1)  = f_big(0:nx/2 , 0:nz/2-1     , qy) 
      ftemp_send(: , nz/2:nz-1) = f_big(0:nx/2 , mz-nz/2:mz-1 , qy)
      CALL MPI_SEND(ftemp_send,totsizec,MPI_MYCOMPLEX,receiver,10,MPI_COMM_WORLD,ierr)
    END IF
    IF (myid.eq.receiver) THEN
      CALL MPI_RECV(ftemp_recv,totsizec,MPI_MYCOMPLEX,sender,10,MPI_COMM_WORLD,status_mpi,ierr)
      qy_recv=qqy-ystart(receiver)
      f_small(:,:,qy_recv) = ftemp_recv
    END IF   
  END DO

  DO qqy = my-ny/2, my-1
    sender = nodeyB(qqy)
    receiver=nodey(qqy+ny-my)
    qy=qqy-ystartB(sender)
!    write(*,*) 'compress : qqy=',qqy, '    sender = ', sender, '   receiver =', receiver
    IF (myid.eq.sender) THEN
      ftemp_send(: , 0:nz/2-1)  = f_big(0:nx/2 , 0:nz/2-1     , qy) 
      ftemp_send(: , nz/2:nz-1) = f_big(0:nx/2 , mz-nz/2:mz-1 , qy)
      CALL MPI_SEND(ftemp_send,totsizec,MPI_MYCOMPLEX,receiver,10,MPI_COMM_WORLD,ierr)
    END IF
    IF (myid.eq.receiver) THEN
      CALL MPI_RECV(ftemp_recv,totsizec,MPI_MYCOMPLEX,sender,10,MPI_COMM_WORLD,status_mpi,ierr)
      qy_recv=qqy+ny-my-ystart(receiver)
      f_small(:,:,qy_recv) = ftemp_recv
    END IF   
  END DO
  
  f_small=f_small*fac

  DEALLOCATE(ftemp_send,ftemp_recv)
  
END SUBROUTINE compress


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                     multiple_expand                      !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
SUBROUTINE multiple_expand(nn,f_small,f_big)        
      
  USE parameters
  USE new_sizes
  USE mpi_var
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: nn
  COMPLEX, INTENT(IN), DIMENSION(0:cx,0:cz,0:cy,nn)       :: f_small
  COMPLEX, INTENT(OUT), DIMENSION(0:ccx,0:ccz,0:ccy,nn)   :: f_big
  INTEGER :: ii
  COMPLEX, ALLOCATABLE, DIMENSION (:,:,:)        :: tn, tm
  
  ALLOCATE(tn(0:cx,0:cz,0:cy),tm(0:ccx,0:ccz,0:ccy))

  DO ii=1,nn
     IF (myid.eq.ioid) WRITE(6,*) 'In multiple expand; i = ', ii
     tn=f_small(:,:,:,ii)
     CALL expand(tn,tm)
     f_big(:,:,:,ii)=tm
  END DO  
  
  DEALLOCATE(tn,tm)
  
END SUBROUTINE multiple_expand

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                     multiple_compress                    !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

SUBROUTINE multiple_compress(nn,f_big,f_small)     

  USE parameters
  USE new_sizes
  USE mpi_var
  IMPLICIT NONE
  
  INTEGER, INTENT(IN) :: nn
  COMPLEX, INTENT(IN)    :: f_big(0:ccx,0:ccz,0:ccy,nn)
  COMPLEX, INTENT(OUT)   :: f_small(0:cx,0:cz,0:cy,nn)
  INTEGER :: ii
  COMPLEX, ALLOCATABLE, DIMENSION (:,:,:)        :: tn, tm
  
  ALLOCATE(tn(0:cx,0:cz,0:cy),tm(0:ccx,0:ccz,0:ccy))

  DO ii=1,nn
     tm=f_big(:,:,:,ii)
     CALL compress(tm,tn)
     f_small(:,:,:,ii)=tn
  END DO  
  
  DEALLOCATE(tn,tm)

  
END SUBROUTINE multiple_compress


  