!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!  12 August 2011                                          !!
!!                VTK Files (for Paraview)                  !!
!!                    Post-Procesing                        !!
!!                                                          !!
!! vtk_mod                                                  !!
!! vtk                                                      !!
!! vtk_read                                                 !!
!! vtk_output                                               !!
!! vtk_write_vec                                            !!
!! vtk_write_sca                                            !!
!! vtk_write_vec_exact                                      !!
!! vtk_write_sca_exact                                      !!
!! vtk_write_vec_interp                                     !!
!! vtk_interpolate_spline1                                  !!
!! vtk_interpolate_spline3                                  !!
!! tra_spline1_Ffull                                        !!
!! tra_spline1_Flow                                         !!
!! tra_spline1_Fup                                          !!
!! tra_spline3_Ffull                                        !!
!! tra_spline3_Flow                                         !!
!! tra_spline3_Fup                                          !!
!! tra_proc_id                                              !!
!! transfer_slice_real                                      !!
!! compute_curll                                            !!
!! correl_real                                              !!
!!                                        version 2.05_0.90 !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                       vtk_mod                            !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
MODULE vtk_mod

  INTEGER   :: VTK_TYPE, VTK_interp, VTK_velocity, VTK_vorticity, VTK_magnetic, VTK_curent, VTK_electric, VTK_scalar, VTK_BEcorrelations
  INTEGER   :: VTK_nx, VTK_ny, VTK_nz
  CHARACTER(LEN=2) :: inum
  REAL      :: VTK_ox, VTK_oy, VTK_oz
  REAL      :: VTK_lx, VTK_ly, VTK_lz
  LOGICAL   :: VTK_SPLINE
  NAMELIST /vtk_files/  VTK_TYPE, VTK_interp,VTK_nx, VTK_ny, VTK_nz, VTK_ox, VTK_oy, VTK_oz, VTK_lx, VTK_ly, VTK_lz, VTK_velocity, VTK_vorticity, VTK_magnetic, VTK_curent, VTK_electric, VTK_scalar, VTK_BEcorrelations

END MODULE vtk_mod



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                          vtk                             !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
PROGRAM vtk
  USE parameters
  USE variables
  USE mpi_var
  USE vtk_mod
  IMPLICIT NONE
 
  INTEGER                         :: rc
  CHARACTER(LEN=namelength+8)     :: filename
  CHARACTER(LEN=3)                :: cnum
  CHARACTER(LEN=2)                :: csc 
  INTEGER                         :: iscal
  
  CALL mpi_environment_init()    
    
  IF (my_fpart.eq.io_fpart) THEN
    WRITE(out_unit,*) '>>   VTK post processing : '
    WRITE(out_unit,*) '>> simulation name is ', simname  
  END IF

  CALL read_para()  
  CALL read_time()
  CALL vtk_read()

  CALL init_fft3d()
  CALL init_wavevectors()
  
  WRITE(inum,'(i2.2)') my_inst  

  IF(VELEQ) THEN
    ALLOCATE(vel(0:cx,0:cz,0:cy,3))
    CALL read_vec_divfree(vel,simname//'_u')
  END IF
  IF(MAGEQ) THEN
    ALLOCATE(mag(0:cx,0:cz,0:cy,3))
	CALL read_vec_divfree(mag,simname//'_b')
  END IF
  IF (SCAEQ) THEN
    ALLOCATE(scal(0:cx,0:cz,0:cy,NSCAL))
    DO iscal=1,NSCAL
      WRITE(csc,'(i2.2)') iscal
      CALL read_scal(scal(:,:,:,iscal),simname//'_s'//csc//'.')
	END DO
  END IF
  IF (my_fpart.EQ.io_fpart) THEN
    WRITE(cnum,'(i3.3)') nfields
    WRITE(out_unit,*) '>> The source files that will be used to output vtk files are number:'
    WRITE(out_unit,*) '>>        ', nfields
  END IF 
 
  SELECT CASE(VTK_TYPE)  
  CASE(1) !! Exact fields
    CALL vtk_output()
    IF (my_fpart.EQ.io_fpart) WRITE(out_unit,*) '>> VTK output performed for exact fields.'
  CASE(2) !! Interpolated fields
    CALL vtk_output()
    IF (my_fpart.EQ.io_fpart) WRITE(out_unit,*) '>> VTK output performed for interpolated fields.'
  CASE DEFAULT
    IF (my_fpart.EQ.io_fpart) WRITE(out_unit,*) '>> VTK output NOT performed.'
  END SELECT
    
  CALL mpi_environment_end()  

END PROGRAM vtk



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                       vtk_read                           !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE vtk_read()
  USE parameters
  USE mpi_var
  USE vtk_mod
  IMPLICIT NONE

  CHARACTER(LEN=namelength+4)                      :: filename
  filename=simname//'.par'

  IF (my_fpart.EQ.io_fpart) THEN
  !IF (myid.eq.ioid) THEN 
    OPEN(10,FILE=filename,STATUS='OLD',FORM='FORMATTED')
    READ(unit=10,NML=vtk_files)
    CLOSE(10)
  END IF

  IF(VTK_TYPE.eq.2) THEN  
    IF(VTK_ox.ge.VTK_lx) THEN
      IF (my_fpart.EQ.io_fpart) WRITE(out_unit,*) '>> The origin VTK_ox must be smaler then the box lenght VTK_lx'
      STOP
    END IF
    IF(VTK_ox.ge.VTK_lx) THEN
      IF (my_fpart.EQ.io_fpart) WRITE(out_unit,*) '>> The origin VTK_oy must be smaler then the box lenght VTK_ly'
      STOP
    END IF
    IF(VTK_ox.ge.VTK_lx) THEN
      IF (my_fpart.EQ.io_fpart) WRITE(out_unit,*) '>> The origin VTK_oz must be smaler then the box lenght VTK_lz'
      STOP
    END IF
  END IF
  
  VTK_ox=VTK_ox*pi
  VTK_oy=VTK_oy*pi
  VTK_oz=VTK_oz*pi
  VTK_lx=VTK_lx*pi
  VTK_ly=VTK_ly*pi
  VTK_lz=VTK_lz*pi
  
  CALL MPI_BCAST(VTK_TYPE,1,MPI_INTEGER,io_fpart,MPI_COMM_INSTANCE,ierr)
  CALL MPI_BCAST(VTK_interp,1,MPI_INTEGER,io_fpart,MPI_COMM_INSTANCE,ierr) 
  CALL MPI_BCAST(VTK_nx,1,MPI_INTEGER,io_fpart,MPI_COMM_INSTANCE,ierr)
  CALL MPI_BCAST(VTK_ny,1,MPI_INTEGER,io_fpart,MPI_COMM_INSTANCE,ierr)
  CALL MPI_BCAST(VTK_nz,1,MPI_INTEGER,io_fpart,MPI_COMM_INSTANCE,ierr)
  CALL MPI_BCAST(VTK_ox,1,MPI_MYREAL,io_fpart,MPI_COMM_INSTANCE,ierr)
  CALL MPI_BCAST(VTK_oy,1,MPI_MYREAL,io_fpart,MPI_COMM_INSTANCE,ierr)
  CALL MPI_BCAST(VTK_oz,1,MPI_MYREAL,io_fpart,MPI_COMM_INSTANCE,ierr)
  CALL MPI_BCAST(VTK_lx,1,MPI_MYREAL,io_fpart,MPI_COMM_INSTANCE,ierr)
  CALL MPI_BCAST(VTK_ly,1,MPI_MYREAL,io_fpart,MPI_COMM_INSTANCE,ierr)
  CALL MPI_BCAST(VTK_lz,1,MPI_MYREAL,io_fpart,MPI_COMM_INSTANCE,ierr)   
  CALL MPI_BCAST(VTK_velocity,1,MPI_INTEGER,io_fpart,MPI_COMM_INSTANCE,ierr)
  CALL MPI_BCAST(VTK_vorticity,1,MPI_INTEGER,io_fpart,MPI_COMM_INSTANCE,ierr)
  CALL MPI_BCAST(VTK_magnetic,1,MPI_INTEGER,io_fpart,MPI_COMM_INSTANCE,ierr)
  CALL MPI_BCAST(VTK_curent,1,MPI_INTEGER,io_fpart,MPI_COMM_INSTANCE,ierr)
  CALL MPI_BCAST(VTK_electric,1,MPI_INTEGER,io_fpart,MPI_COMM_INSTANCE,ierr)
  CALL MPI_BCAST(VTK_scalar,1,MPI_INTEGER,io_fpart,MPI_COMM_INSTANCE,ierr)
  CALL MPI_BCAST(VTK_BEcorrelations,1,MPI_INTEGER,io_fpart,MPI_COMM_INSTANCE,ierr)
  
  VTK_SPLINE=.false.
  IF(VTK_interp==1) VTK_SPLINE=.true.

END SUBROUTINE vtk_read



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                       vtk_output                         !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE vtk_output()
  USE parameters
  USE variables
  USE mpi_var
  USE vtk_mod
  IMPLICIT NONE
   
  REAL, ALLOCATABLE, DIMENSION (:,:,:,:)      :: ur, wr, br, jr, er
  REAL, ALLOCATABLE, DIMENSION (:,:,:)        :: sr
  COMPLEX, ALLOCATABLE, DIMENSION (:,:,:,:)   :: vor, cur, elc
  COMPLEX, ALLOCATABLE, DIMENSION (:,:,:)     :: c1
  CHARACTER(LEN=3)                            :: cnum
  CHARACTER(LEN=2)                            :: csc 
  INTEGER                                     :: iscal

  ALLOCATE(sr(0:rx,0:ry,0:rz), c1(0:cx,0:cz,0:cy))
  WRITE(cnum,'(i3.3)') nfields

  IF(VELEQ) THEN
    ALLOCATE(ur(0:rx,0:ry,0:rz,3))
	c1=vel(:,:,:,1)
    CALL ifft3ds(c1,sr)
    ur(:,:,:,1)=sr
    c1=vel(:,:,:,2)
    CALL ifft3ds(c1,sr)
    ur(:,:,:,2)=sr
    c1=vel(:,:,:,3)
    CALL ifft3ds(c1,sr)
    ur(:,:,:,3)=sr
    IF(VTK_velocity.EQ.1) CALL vtk_write_vec(ur,simname//'_u00.'//cnum//'.vtk')
	IF(VTK_vorticity.EQ.1) THEN
      ALLOCATE(wr(0:rx,0:ry,0:rz,3), vor(0:cx,0:cz,0:cy,3))
      CALL compute_curll(vel,vor)
 	  c1=vor(:,:,:,1)
      CALL ifft3ds(c1,sr)
      wr(:,:,:,1)=sr
	  c1=vor(:,:,:,2)
      CALL ifft3ds(c1,sr)
      wr(:,:,:,2)=sr
      c1=vor(:,:,:,3)
      CALL ifft3ds(c1,sr)
      wr(:,:,:,3)=sr
      CALL vtk_write_vec(wr,simname//'_w00.'//cnum//'.vtk') 
      DEALLOCATE(wr, vor)
    END IF
	IF(VTK_electric.EQ.0) DEALLOCATE(ur)
  END IF
    
  IF(MAGEQ) THEN
    ALLOCATE(br(0:rx,0:ry,0:rz,3))
    c1=mag(:,:,:,1)
    CALL ifft3ds(c1,sr)
    br(:,:,:,1)=sr
  	c1=mag(:,:,:,2)
    CALL ifft3ds(c1,sr)
    br(:,:,:,2)=sr
    c1=mag(:,:,:,3)
    CALL ifft3ds(c1,sr)
    br(:,:,:,3)=sr
    IF(VTK_magnetic.EQ.1) CALL vtk_write_vec(br,simname//'_b00.'//cnum//'.vtk') 
    IF((VTK_curent.EQ.1).OR.(VTK_electric.EQ.1)) THEN
      ALLOCATE(jr(0:rx,0:ry,0:rz,3), cur(0:cx,0:cz,0:cy,3))
      CALL compute_curll(mag,cur)
      c1=cur(:,:,:,1)
      CALL ifft3ds(c1,sr)
      jr(:,:,:,1)=sr
      c1=cur(:,:,:,2)
      CALL ifft3ds(c1,sr)
      jr(:,:,:,2)=sr
      c1=cur(:,:,:,3)
      CALL ifft3ds(c1,sr)
      jr(:,:,:,3)=sr
      IF(VTK_curent.EQ.1) CALL vtk_write_vec(jr,simname//'_j00.'//cnum//'.vtk') 
      DEALLOCATE(cur)
      IF(VTK_electric.EQ.0) DEALLOCATE(jr)
    END IF

	IF(VTK_electric.EQ.1) THEN
      ALLOCATE(er(0:rx,0:ry,0:rz,3))
      er(:,:,:,1)=-(ur(:,:,:,2)*br(:,:,:,3)-ur(:,:,:,3)*br(:,:,:,2))+eta*jr(:,:,:,1)
      er(:,:,:,2)=-(ur(:,:,:,3)*br(:,:,:,1)-ur(:,:,:,1)*br(:,:,:,3))+eta*jr(:,:,:,2)
      er(:,:,:,3)=-(ur(:,:,:,1)*br(:,:,:,2)-ur(:,:,:,2)*br(:,:,:,1))+eta*jr(:,:,:,3)
      CALL vtk_write_vec(er,simname//'_e00.'//cnum//'.vtk') 

	  IF(VTK_BEcorrelations.EQ.1) THEN
        ALLOCATE(elc(0:cx,0:cz,0:cy,3))
        sr=er(:,:,:,1)
        CALL fft3ds(sr,c1)
        elc(:,:,:,1)=c1
        sr=er(:,:,:,2)
        CALL fft3ds(sr,c1)
        elc(:,:,:,2)=c1
        sr=er(:,:,:,3)
        CALL fft3ds(sr,c1)
        elc(:,:,:,3)=c1
 
        CALL correl_real(mag(:,:,:,1), mag(:,:,:,1), sr)
        CALL vtk_write_sca(sr,simname//'BxBx.'//cnum//'.vtk') 
        CALL correl_real(mag(:,:,:,2), mag(:,:,:,2), sr)
        CALL vtk_write_sca(sr,simname//'ByBy.'//cnum//'.vtk')
        CALL correl_real(mag(:,:,:,3), mag(:,:,:,3), sr)
        CALL vtk_write_sca(sr,simname//'BzBz.'//cnum//'.vtk')
        CALL correl_real(mag(:,:,:,1), mag(:,:,:,2), sr)
        CALL vtk_write_sca(sr,simname//'BxBy.'//cnum//'.vtk')
        CALL correl_real(mag(:,:,:,1), mag(:,:,:,3), sr)
        CALL vtk_write_sca(sr,simname//'BxBz.'//cnum//'.vtk')
        CALL correl_real(mag(:,:,:,2), mag(:,:,:,3), sr)
        CALL vtk_write_sca(sr,simname//'ByBz.'//cnum//'.vtk')

        CALL correl_real(elc(:,:,:,1), elc(:,:,:,1), sr)
        CALL vtk_write_sca(sr,simname//'ExEx.'//cnum//'.vtk') 
        CALL correl_real(elc(:,:,:,2), elc(:,:,:,2), sr)
        CALL vtk_write_sca(sr,simname//'EyEy.'//cnum//'.vtk')
        CALL correl_real(elc(:,:,:,3), elc(:,:,:,3), sr)
        CALL vtk_write_sca(sr,simname//'EzEz.'//cnum//'.vtk')
        CALL correl_real(elc(:,:,:,1), elc(:,:,:,2), sr)
        CALL vtk_write_sca(sr,simname//'ExEy.'//cnum//'.vtk')
        CALL correl_real(elc(:,:,:,1), elc(:,:,:,3), sr)
        CALL vtk_write_sca(sr,simname//'ExEz.'//cnum//'.vtk')
        CALL correl_real(elc(:,:,:,2), elc(:,:,:,3), sr)
        CALL vtk_write_sca(sr,simname//'EyEz.'//cnum//'.vtk')
   
        CALL correl_real(mag(:,:,:,1), elc(:,:,:,1), sr)
        CALL vtk_write_sca(sr,simname//'BxEx.'//cnum//'.vtk') 
        CALL correl_real(mag(:,:,:,1), elc(:,:,:,2), sr)
        CALL vtk_write_sca(sr,simname//'BxEy.'//cnum//'.vtk')
        CALL correl_real(mag(:,:,:,1), elc(:,:,:,3), sr)
        CALL vtk_write_sca(sr,simname//'BxEz.'//cnum//'.vtk')

        CALL correl_real(mag(:,:,:,2), elc(:,:,:,1), sr)
        CALL vtk_write_sca(sr,simname//'ByEx.'//cnum//'.vtk')
        CALL correl_real(mag(:,:,:,2), elc(:,:,:,2), sr)
        CALL vtk_write_sca(sr,simname//'ByEy.'//cnum//'.vtk')
        CALL correl_real(mag(:,:,:,2), elc(:,:,:,3), sr)
        CALL vtk_write_sca(sr,simname//'ByEz.'//cnum//'.vtk')

        CALL correl_real(mag(:,:,:,3), elc(:,:,:,1), sr)
        CALL vtk_write_sca(sr,simname//'BzEx.'//cnum//'.vtk')
        CALL correl_real(mag(:,:,:,3), elc(:,:,:,2), sr)
        CALL vtk_write_sca(sr,simname//'BzEy.'//cnum//'.vtk')
        CALL correl_real(mag(:,:,:,3), elc(:,:,:,3), sr)
        CALL vtk_write_sca(sr,simname//'BzEz.'//cnum//'.vtk')
        DEALLOCATE(elc)
	  END IF

      DEALLOCATE(er, jr, ur)
    END IF
	DEALLOCATE(br)
  END IF

  IF (SCAEQ) THEN
    DO iscal=1,NSCAL
      c1 = scal(:,:,:,iscal)
      CALL ifft3ds(c1,sr) 
      WRITE(csc,'(i2.2)') iscal
      IF(VTK_scalar.EQ.1) CALL vtk_write_sca(sr,simname//'_c'//csc//'.'//cnum//'.vtk') 
	END DO
  END IF

  DEALLOCATE(c1,sr)

END SUBROUTINE vtk_output



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                    vtk_write_vec                         !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE vtk_write_vec(a1,vtk_file)
  USE parameters
  USE variables
  USE mpi_var
  USE vtk_mod
  IMPLICIT NONE  

  REAL, DIMENSION(0:rx,0:ry,0:rz,3), INTENT(IN)    :: a1
  CHARACTER(LEN=namelength+12), INTENT(IN)         :: vtk_file

  SELECT CASE(VTK_TYPE)  
  CASE(1) !! Exact fields
    CALL vtk_write_vec_exact(a1,vtk_file)
  CASE(2) !! Interpolated fields
    CALL vtk_write_vec_interp(a1,vtk_file)
  CASE DEFAULT
    WRITE(6,*) 'wrong value of VTK_interp parameter: ',VTK_interp
    STOP
  END SELECT
  
END SUBROUTINE vtk_write_vec



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                    vtk_write_sca                         !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE vtk_write_sca(s1,vtk_file)
  USE parameters
  USE variables
  USE mpi_var
  USE vtk_mod
  IMPLICIT NONE  

  REAL, DIMENSION(0:rx,0:ry,0:rz), INTENT(IN)      :: s1
  CHARACTER(LEN=namelength+12), INTENT(IN)         :: vtk_file

  SELECT CASE(VTK_TYPE)  
  CASE(1) !! Exact fields
    CALL vtk_write_sca_exact(s1,vtk_file)
  CASE(2) !! Interpolated fields
    !CALL vtk_write_sca_interp(s1,vtk_file)
    WRITE(6,*) 'vtk_write_sca_interp nor done yet'
    STOP
  CASE DEFAULT
    WRITE(6,*) 'wrong value of VTK_interp parameter: ',VTK_interp
    STOP
  END SELECT
  
END SUBROUTINE vtk_write_sca



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                  vtk_write_vec_exact                     !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE vtk_write_vec_exact(a1,vtk_file)
  USE parameters
  USE variables
  USE mpi_var
  USE vtk_mod
  IMPLICIT NONE  

  REAL, DIMENSION(0:rx,0:ry,0:rz,3), INTENT(IN)    :: a1
  CHARACTER(LEN=namelength+12), INTENT(IN)         :: vtk_file
  REAL, ALLOCATABLE, DIMENSION(:,:,:)              :: r0, r1  
  REAL, ALLOCATABLE, DIMENSION(:,:)                :: utempx, utempy, utempz
  CHARACTER(LEN=1), PARAMETER                      :: lf=char(10)  !! line feed character  
  CHARACTER(LEN=11)                                :: str1, str2, str3  
  CHARACTER(LEN=80)                                :: buff
  INTEGER                                          :: qx, qy, qz, pid, qqz
  REAL(KIND=4)                                     :: out

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !! Write the VTK file header 
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  IF (my_fpart.EQ.io_fpart) THEN
    IF(numinsts.GT.1.0)THEN
      OPEN(10, FILE=inum//'_'//vtk_file, FORM='binary', CONVERT='big_endian')
    ELSE
      OPEN(10, FILE=vtk_file, FORM='binary', CONVERT='big_endian')
    END IF
    buff= '# vtk DataFile Version 3.0'//lf                                            
    WRITE(10) TRIM(buff)
    
    buff= 'TURBO vectorial field'//lf                                                             
    WRITE(10) TRIM(buff)
    
    buff= 'BINARY'//lf                                                                 
    WRITE(10) TRIM(buff)
    
    buff= 'DATASET STRUCTURED_POINTS'//lf                                         
    WRITE(10) TRIM(buff)
    
    WRITE(str1,'(A1,I10)') ' ', nx+1
    WRITE(str2,'(A1,I10)') ' ', ny+1
    WRITE(str3,'(A1,I10)') ' ', nz+1
    buff = 'DIMENSIONS'//str1//str2//str3//lf
    WRITE(10) TRIM(buff)
  
    buff= 'ORIGIN  0.000000  0.000000  0.000000'//lf
    WRITE(10) TRIM(buff)
  
    WRITE(str1,'(A1,F10.6)') ' ', dx
    WRITE(str2,'(A1,F10.6)') ' ', dy
    WRITE(str3,'(A1,F10.6)') ' ', dz
    buff= 'SPACING'//str1//str2//str3//lf
    WRITE(10) TRIM(buff)
  
    WRITE(str1,'(A1,I10)') ' ', (nx+1)*(ny+1)*(nz+1)
    buff= 'POINT_DATA'//str1//lf
    WRITE(10) TRIM(buff)
  
    buff= 'VECTORS vectors float'//lf                 
    WRITE(10) TRIM(buff)
  END IF


  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !! Collect the field information and write it to file
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  IF (my_fpart.EQ.io_fpart) ALLOCATE(r0(0:nx,0:ny,3), r1(0:nx,0:ny,3))
  ALLOCATE(utempx(0:rx,0:ry),utempy(0:rx,0:ry),utempz(0:rx,0:ry))

  pid=whereis_z(0,1)
  qqz=whereis_z(0,2)
  CALL transfer_slice_real(a1(:,:,qqz,1),pid,utempx,io_fpart) ! ioid)
  CALL transfer_slice_real(a1(:,:,qqz,2),pid,utempy,io_fpart) ! ioid)
  CALL transfer_slice_real(a1(:,:,qqz,3),pid,utempz,io_fpart) ! ioid)
  IF (my_fpart.EQ.io_fpart) THEN
    r0(0:nx-1,0:ny-1,1)=utempx
    r0(0:nx-1,0:ny-1,2)=utempy
    r0(0:nx-1,0:ny-1,3)=utempz
    r0(nx,:,1) = r0(0,:,1)
    r0(nx,:,2) = r0(0,:,2)
    r0(nx,:,3) = r0(0,:,3)
    r0(:,ny,1) = r0(:,0,1)
    r0(:,ny,2) = r0(:,0,2)
    r0(:,ny,3) = r0(:,0,3) 
    DO qy=0, ny
      DO qx=0, nx
        out=r0(qx,qy,1)
        WRITE(10) out
        out=r0(qx,qy,2)
        WRITE(10) out
        out=r0(qx,qy,3)
        WRITE(10) out 
      END DO
    END DO
  END IF  
    
  DO qz=1, nz-1
    pid=whereis_z(qz,1)
    qqz=whereis_z(qz,2)
    CALL transfer_slice_real(a1(:,:,qqz,1),pid,utempx,io_fpart) ! ioid)
    CALL transfer_slice_real(a1(:,:,qqz,2),pid,utempy,io_fpart) ! ioid)
    CALL transfer_slice_real(a1(:,:,qqz,3),pid,utempz,io_fpart) ! ioid)
    IF(my_fpart.EQ.io_fpart) THEN
      r1(0:nx-1,0:ny-1,1)=utempx
      r1(0:nx-1,0:ny-1,2)=utempy
      r1(0:nx-1,0:ny-1,3)=utempz
      r1(nx,:,1) = r1(0,:,1)
      r1(nx,:,2) = r1(0,:,2)
      r1(nx,:,3) = r1(0,:,3)
      r1(:,ny,1) = r1(:,0,1)
      r1(:,ny,2) = r1(:,0,2)
      r1(:,ny,3) = r1(:,0,3)      
      DO qy=0, ny
        DO qx=0, nx
          out=r1(qx,qy,1)     
          WRITE(10) out
          out=r1(qx,qy,2)   
          WRITE(10) out
          out=r1(qx,qy,3)    
          WRITE(10) out         
        END DO
      END DO
    END IF
  END DO  
  DEALLOCATE(utempx,utempy,utempz)
  
  IF (my_fpart.EQ.io_fpart) THEN
    DO qy=0, ny
      DO qx=0, nx
        out=r0(qx,qy,1)
        WRITE(10) out
        out=r0(qx,qy,2)
        WRITE(10) out
        out=r0(qx,qy,3)
        WRITE(10) out 
      END DO
    END DO
    DEALLOCATE(r0, r1)
    CLOSE(10)
  END IF 
  
END SUBROUTINE vtk_write_vec_exact



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                vtk_write_sca_exact                       !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE vtk_write_sca_exact(s1,vtk_file)
  USE parameters
  USE variables
  USE mpi_var
  USE vtk_mod
  IMPLICIT NONE  

  REAL, DIMENSION(0:rx,0:ry,0:rz), INTENT(IN)      :: s1
  CHARACTER(LEN=namelength+12), INTENT(IN)         :: vtk_file
  REAL, ALLOCATABLE, DIMENSION(:,:)                :: r0, r1  
  REAL, ALLOCATABLE, DIMENSION(:,:)                :: stemp
  CHARACTER(LEN=1), PARAMETER                      :: lf=char(10)  !! line feed character  
  CHARACTER(LEN=11)                                :: str1, str2, str3  
  CHARACTER(LEN=80)                                :: buff
  INTEGER                                          :: qx, qy, qz, pid, qqz
  REAL(KIND=4)                                     :: out

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !! Write the VTK file header 
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  IF (my_fpart.EQ.io_fpart) THEN
    IF(numinsts.GT.1.0)THEN
      OPEN(10, FILE=inum//'_'//vtk_file, FORM='binary', CONVERT='big_endian')
    ELSE
      OPEN(10, FILE=vtk_file, FORM='binary', CONVERT='big_endian')
    END IF
    buff= '# vtk DataFile Version 3.0'//lf                                            
    WRITE(10) TRIM(buff)
    
    buff= 'TURBO scalar field'//lf                                                             
    WRITE(10) TRIM(buff)
    
    buff= 'BINARY'//lf                                                                 
    WRITE(10) TRIM(buff)
    
    buff= 'DATASET STRUCTURED_POINTS'//lf                                         
    WRITE(10) TRIM(buff)
    
    WRITE(str1,'(A1,I10)') ' ', nx+1
    WRITE(str2,'(A1,I10)') ' ', ny+1
    WRITE(str3,'(A1,I10)') ' ', nz+1
    buff = 'DIMENSIONS'//str1//str2//str3//lf
    WRITE(10) TRIM(buff)
  
    WRITE(str1,'(A1,F10.6)') ' ', dx
    WRITE(str2,'(A1,F10.6)') ' ', dy
    WRITE(str3,'(A1,F10.6)') ' ', dz
    buff= 'SPACING'//str1//str2//str3//lf
    WRITE(10) TRIM(buff)
  
    buff= 'ORIGIN  0.000000  0.000000  0.000000'//lf
    WRITE(10) TRIM(buff)
    
    WRITE(str1,'(A1,I10)') ' ', (nx+1)*(ny+1)*(nz+1)
    buff= 'POINT_DATA'//str1//lf
    WRITE(10) TRIM(buff)
  
    buff= 'SCALARS scalars float'//lf                 
    WRITE(10) TRIM(buff)
    
    buff= 'LOOKUP_TABLE default'//lf                 
    WRITE(10) TRIM(buff)
  END IF


  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !! Collect the field information and write it to file
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  IF (my_fpart.EQ.io_fpart) ALLOCATE(r0(0:nx,0:ny), r1(0:nx,0:ny))
  ALLOCATE(stemp(0:rx,0:ry))

  pid=whereis_z(0,1)
  qqz=whereis_z(0,2)
  CALL transfer_slice_real(s1(:,:,qqz),pid,stemp,io_fpart) ! ioid)
  IF (my_fpart.EQ.io_fpart) THEN
    r0(0:nx-1,0:ny-1)=stemp
    r0(nx,:) = r0(0,:)
    r0(:,ny) = r0(:,0) 
    DO qy=0, ny
      DO qx=0, nx
        out=r0(qx,qy)
        WRITE(10) out
      END DO
    END DO
  END IF  
    
  DO qz=1, nz-1
    pid=whereis_z(qz,1)
    qqz=whereis_z(qz,2)
    CALL transfer_slice_real(s1(:,:,qqz),pid,stemp,io_fpart) ! ioid)
    IF (my_fpart.EQ.io_fpart) THEN
      r1(0:nx-1,0:ny-1)=stemp
      r1(nx,:) = r1(0,:)
      r1(:,ny) = r1(:,0)      
      DO qy=0, ny
        DO qx=0, nx
          out=r1(qx,qy)
          WRITE(10) out
        END DO
      END DO
    END IF
  END DO  
  DEALLOCATE(stemp)
  
  IF (my_fpart.EQ.io_fpart) THEN
    DO qy=0, ny
      DO qx=0, nx
        WRITE(10) r0(qx,qy)
      END DO
    END DO
    DEALLOCATE(r0, r1)
    CLOSE(10)
  END IF 
  
END SUBROUTINE vtk_write_sca_exact



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                vtk_write_vec_interp                      !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE vtk_write_vec_interp(a1,vtk_file)
  USE parameters
  USE variables
  USE mpi_var
  USE vtk_mod
  IMPLICIT NONE

  REAL, DIMENSION(0:rx,0:ry,0:rz,3), INTENT(IN)    :: a1
  CHARACTER(LEN=namelength+12), INTENT(IN)         :: vtk_file
  REAL, DIMENSION(3)                               :: point 
  REAL                                             :: VTK_dx, VTK_dy, VTK_dz 
  INTEGER                                          :: qx, qy, qz, up_fpart, low_fpart
  CHARACTER(LEN=1), PARAMETER                      :: lf=char(10)  !! line feed character  
  CHARACTER(LEN=11)                                :: str1, str2, str3  
  CHARACTER(LEN=80)                                :: buff
  REAL(KIND=4)                                     :: out
  
  COMPLEX, ALLOCATABLE, DIMENSION (:,:,:)          :: c1
  REAL   , ALLOCATABLE, DIMENSION (:,:,:)          :: r1
  COMPLEX, ALLOCATABLE, DIMENSION (:,:,:,:)        :: grad
  REAL   , ALLOCATABLE, DIMENSION (:,:,:,:,:)      :: da1
  REAL, ALLOCATABLE, DIMENSION(:,:,:)              :: field_val
 
  IF (VTK_SPLINE) THEN
    ALLOCATE(c1(0:cx,0:cz,0:cy), r1(0:rx,0:ry,0:rz))
    ALLOCATE(grad(0:cx,0:cz,0:cy,3))
    ALLOCATE(da1(0:rx, 0:ry, 0:rz, 3, 3))
    r1 = 0.0
    da1 = 0.0
    grad = 0.0
    r1(0:rx-2,0:ry,0:rz) = a1(0:rx-2,0:ry,0:rz,1)
    CALL fft3ds(r1,c1)
    DO qy=0, cy
      DO qz=0, cz
        DO qx=0, cx
          grad(qx,qz,qy,1)=ikx(qx)*c1(qx,qz,qy)
          grad(qx,qz,qy,2)=iky(qy)*c1(qx,qz,qy)
          grad(qx,qz,qy,3)=ikz(qz)*c1(qx,qz,qy)
        END DO
      END DO
    END DO
    c1=grad(:,:,:,1)
    CALL ifft3ds(c1,r1)
    da1(0:nx-1,0:ry,0:rz,1,1)=r1(0:rx-2,0:ry,0:rz)
    c1=grad(:,:,:,2)
    CALL ifft3ds(c1,r1)
    da1(0:nx-1,0:ry,0:rz,1,2)=r1(0:rx-2,0:ry,0:rz)
    c1=grad(:,:,:,3)
    CALL ifft3ds(c1,r1)
    da1(0:nx-1,0:ry,0:rz,1,3)=r1(0:rx-2,0:ry,0:rz)
      
    r1 = 0.0
    r1(0:rx-2,0:ry,0:rz) = a1(0:nx-1,0:ry,0:rz,2)
    CALL fft3ds(r1,c1)
    DO qy=0, cy
      DO qz=0, cz
        DO qx=0, cx
          grad(qx,qz,qy,1)=ikx(qx)*c1(qx,qz,qy)
          grad(qx,qz,qy,2)=iky(qy)*c1(qx,qz,qy)
          grad(qx,qz,qy,3)=ikz(qz)*c1(qx,qz,qy)
        END DO
      END DO
    END DO
    c1=grad(:,:,:,1)
    CALL ifft3ds(c1,r1)
    da1(0:nx-1,0:ry,0:rz,2,1)=r1(0:rx-2,0:ry,0:rz)
    c1=grad(:,:,:,2)
    CALL ifft3ds(c1,r1)
    da1(0:nx-1,0:ry,0:rz,2,2)=r1(0:rx-2,0:ry,0:rz)
    c1=grad(:,:,:,3)
    CALL ifft3ds(c1,r1)
    da1(0:nx-1,0:ry,0:rz,2,3)=r1(0:rx-2,0:ry,0:rz)
      
    r1 = 0.0
    r1(0:rx-2,0:ry,0:rz) = a1(0:nx-1,0:ry,0:rz,3)
    CALL fft3ds(r1,c1)
    DO qy=0, cy
      DO qz=0, cz
        DO qx=0, cx
          grad(qx,qz,qy,1)=ikx(qx)*c1(qx,qz,qy)
          grad(qx,qz,qy,2)=iky(qy)*c1(qx,qz,qy)
          grad(qx,qz,qy,3)=ikz(qz)*c1(qx,qz,qy)
        END DO
      END DO
    END DO
    c1=grad(:,:,:,1)
    CALL ifft3ds(c1,r1)
    da1(0:nx-1,0:ry,0:rz,3,1)=r1(0:rx-2,0:ry,0:rz)
    c1=grad(:,:,:,2)
    CALL ifft3ds(c1,r1)
    da1(0:nx-1,0:ry,0:rz,3,2)=r1(0:rx-2,0:ry,0:rz)
    c1=grad(:,:,:,3)
    CALL ifft3ds(c1,r1)
    da1(0:nx-1,0:ry,0:rz,3,3)=r1(0:rx-2,0:ry,0:rz)
    
    DEALLOCATE(c1,r1)
    DEALLOCATE(grad)
  END IF

  VTK_dx = (VTK_lx-VTK_ox)/REAL(VTK_nx)
  VTK_dy = (VTK_ly-VTK_oy)/REAL(VTK_ny)
  VTK_dz = (VTK_lz-VTK_oz)/REAL(VTK_nz)
  
  IF (my_fpart.EQ.io_fpart) THEN
    IF(numinsts.GT.1.0)THEN
      OPEN(10, FILE=inum//'_'//vtk_file, FORM='binary', CONVERT='big_endian')
    ELSE
      OPEN(10, FILE=vtk_file, FORM='binary', CONVERT='big_endian')
    END IF
    buff= '# vtk DataFile Version 3.0'//lf                                            
    WRITE(10) TRIM(buff)
    
    buff= 'TURBO vectorial field'//lf                                                             
    WRITE(10) TRIM(buff)
    
    buff= 'BINARY'//lf                                                                 
    WRITE(10) TRIM(buff)
    
    buff= 'DATASET STRUCTURED_POINTS'//lf                                         
    WRITE(10) TRIM(buff)
    
    WRITE(str1,'(A1,I10)') ' ', VTK_nx+1
    WRITE(str2,'(A1,I10)') ' ', VTK_ny+1
    WRITE(str3,'(A1,I10)') ' ', VTK_nz+1
    buff = 'DIMENSIONS'//str1//str2//str3//lf
    WRITE(10) TRIM(buff)
    
    WRITE(str1,'(A1,F10.6)') ' ', 0.0+VTK_ox
    WRITE(str2,'(A1,F10.6)') ' ', 0.0+VTK_oy
    WRITE(str3,'(A1,F10.6)') ' ', 0.0+VTK_oz
    buff= 'ORIGIN'//str1//str2//str3//lf
    WRITE(10) TRIM(buff)
  
    WRITE(str1,'(A1,F10.6)') ' ', VTK_dx
    WRITE(str2,'(A1,F10.6)') ' ', VTK_dy
    WRITE(str3,'(A1,F10.6)') ' ', VTK_dz
    buff= 'SPACING'//str1//str2//str3//lf
    WRITE(10) TRIM(buff)
  
    WRITE(str1,'(A1,I10)') ' ', (VTK_nx+1)*(VTK_ny+1)*(VTK_nz+1)
    buff= 'POINT_DATA'//str1//lf
    WRITE(10) TRIM(buff)
  
    buff= 'VECTORS vectors float'//lf                 
    WRITE(10) TRIM(buff)
  END IF
  
  ALLOCATE(field_val(0:VTK_nx,0:VTK_ny,3)) 
  DO qz = 0, VTK_nz
    point(3) = qz*VTK_dz+VTK_oz
    CALL tra_proc_id(point(3),low_fpart,up_fpart)
    DO qy = 0, VTK_ny
      point(2) = qy*VTK_dy+VTK_oy
      DO qx = 0, VTK_nx
        point(1) = qx*VTK_dx+VTK_ox
        IF((my_fpart.EQ.low_fpart).OR.(my_fpart.EQ.up_fpart)) THEN
          IF (VTK_SPLINE) THEN
            CALL vtk_interpolate_spline3(point, a1, da1, field_val(qx,qy,:))
          ELSE
            CALL vtk_interpolate_spline1(point, a1, field_val(qx,qy,:))
          END IF
        END IF
      END DO
    END DO
    IF (io_fpart.NE.low_fpart) THEN
      IF (my_fpart.EQ.low_fpart) CALL MPI_SEND(field_val, 3*(VTK_nx+1)*(VTK_ny+1), MPI_MYREAL, io_fpart, 10, MPI_COMM_INSTANCE, ierr)
      IF (my_fpart.EQ.io_fpart)  CALL MPI_RECV(field_val, 3*(VTK_nx+1)*(VTK_ny+1), MPI_MYREAL, low_fpart, 10, MPI_COMM_INSTANCE, status_mpi, ierr)
    END IF
    IF (my_fpart.EQ.io_fpart) THEN
      DO qy=0, VTK_ny
        DO qx=0, VTK_nx
          out=field_val(qx,qy,1)
          WRITE(10) out
          out=field_val(qx,qy,2)
          WRITE(10) out
          out=field_val(qx,qy,3)
          WRITE(10) out         
        END DO
      END DO
    END IF 
  END DO

  IF (my_fpart.EQ.io_fpart) CLOSE(10)
  IF (VTK_SPLINE) DEALLOCATE(da1)   
  DEALLOCATE(field_val)

END SUBROUTINE vtk_write_vec_interp



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!               vtk_interpolate_spline1                    !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE vtk_interpolate_spline1(p, fr1, F)
  USE parameters
  USE mpi_var
  USE vtk_mod
  IMPLICIT NONE

  REAL, DIMENSION(3), INTENT(IN)                       :: p     !! Interpolation point position
  REAL, DIMENSION(0:rx, 0:ry, 0:rz, 3), INTENT(IN)     :: fr1 
  REAL, DIMENSION(3), INTENT(OUT)                      :: F     !! Interpolated field
    
  REAL       :: xg, yg, zg                                 !! Positions in grid spacing units
  REAL       :: zx,zy,zz                                   !! Slopes for interpolation  
  INTEGER    :: xlow,ylow,zlow,xup,yup,zup,zzlow,zzup      !! Enclosing grid nodes
  INTEGER    :: low_fpart, up_fpart
  REAL, ALLOCATABLE, DIMENSION(:)     :: Flow
  REAL, ALLOCATABLE, DIMENSION(:)     :: Fup

  !!! Determining the distance in grid spacing units
  xg=p(1)/dx
  yg=p(2)/dy
  zg=p(3)/dz

  IF(xg < 0.0) THEN
    xup = nx + INT(MOD(xg,REAL(nx)))    !!! Determining the enclosing grid nodes for -x       
    xlow = xup - 1                      !!! Determining the enclosing grid nodes for -x   
    IF(xup.eq.nx) xup=0                 !!! Maximum grid points are the same as the zero ones because of the periodic boundaries condition  
    zx = 1.0+(xg-INT(xg))               !!! Computing the point slopes   
  ELSE
    xlow = INT(MOD(xg,REAL(nx)))        !!! Determining the enclosing grid nodes for +x        
    xup = xlow + 1                      !!! Determining the enclosing grid nodes for +x
    IF(xup.eq.nx) xup=0                 !!! Maximum grid points are the same as the zero ones because of the periodic boundaries condition  
    zx = xg-INT(xg)                     !!! Computing the point slopes 
  END IF
      
  IF(yg < 0.0) THEN
    yup = ny + INT(MOD(yg,REAL(ny)))
    ylow = yup - 1
    IF(yup.eq.ny) yup=0
    zy = 1.0+(yg-INT(yg))      
  ELSE
    ylow = INT(MOD(yg,REAL(ny)))
    yup = ylow + 1
    IF(yup.eq.ny) yup=0
    zy = yg-INT(yg)      
  END IF

  IF(zg < 0.0) THEN
    zup = nz + INT(MOD(zg,REAL(nz)))
    zlow = zup - 1
    IF(zup.eq.nz) zup=0
    zz = 1.0+(zg-INT(zg))
  ELSE
    zlow = INT(MOD(zg,REAL(nz)))
    zup = zlow + 1
    IF(zup.eq.nz) zup=0
    zz = zg-INT(zg)
  END IF

  !!! Finding the real field index on a comutational node in the Z direction (the MPI direction)
  zzup = whereis_z(zup,2) 
  zzlow= whereis_z(zlow,2)  

  !! the point should be identicall to all processors that enter this subroutine!
  up_fpart  = whereis_z(zup,1)
  low_fpart = whereis_z(zlow,1)
  F = 0.0
    
  !! IF myid is not one of upid or lowid, then my F = 0.0 and I am exiting the subroutine to do other stuff
  IF ((my_fpart.EQ.low_fpart).OR.(my_fpart.EQ.up_fpart)) THEN
    ALLOCATE(Flow(3),  Fup(3))
    Flow = 0.0
    Fup = 0.0
    IF(my_fpart.EQ.low_fpart) THEN
      IF(my_fpart.EQ.up_fpart) THEN
        CALL tra_spline1_Ffull(xlow,ylow,zzlow,xup,yup,zzup,zx,zy,zz,fr1,Flow)
      ELSE
        CALL tra_spline1_Flow(xlow,ylow,zzlow,xup,yup,zx,zy,zz,fr1,Flow)
        CALL MPI_RECV(Fup,3,MPI_MYREAL,up_fpart,10,MPI_COMM_INSTANCE,status_mpi,ierr)
      END IF
    END IF
    IF ((my_fpart.EQ.up_fpart).AND.(up_fpart.NE.low_fpart)) THEN
      CALL tra_spline1_Fup(xlow,ylow,xup,yup,zzup,zx,zy,zz,fr1,Fup)
      CALL MPI_SEND(Fup,3,MPI_MYREAL,low_fpart,10,MPI_COMM_INSTANCE,ierr)
    END IF
    F=Flow+Fup
    DEALLOCATE(Flow, Fup)
  END IF

END SUBROUTINE vtk_interpolate_spline1



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!               vtk_interpolate_spline3                    !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE vtk_interpolate_spline3(p, fr1, dfr1, F)
  USE parameters
  USE mpi_var
  USE vtk_mod
  IMPLICIT NONE

  REAL, DIMENSION(3), INTENT(IN)                      :: p     !! Interpolation point position
  REAL, DIMENSION(0:rx, 0:ry, 0:rz, 3), INTENT(IN)    :: fr1
  REAL, DIMENSION(0:rx, 0:ry, 0:rz, 3, 3), INTENT(IN) :: dfr1
  REAL, DIMENSION(3), INTENT(OUT)                     :: F     !! Interpolated field
    
  REAL       :: xg, yg, zg                                 !! Positions in grid spacing units
  REAL       :: zx,zy,zz                                   !! Slopes for interpolation  
  INTEGER    :: xlow,ylow,zlow,xup,yup,zup,zzlow,zzup      !! Enclosing grid nodes
  INTEGER    :: low_fpart, up_fpart ! lowid, upid
  REAL, ALLOCATABLE, DIMENSION(:)     :: Flow
  REAL, ALLOCATABLE, DIMENSION(:)     :: Fup

  !!! Determining the distance in grid spacing units
  xg=p(1)/dx
  yg=p(2)/dy
  zg=p(3)/dz

  IF(xg < 0.0) THEN
    xup = nx + INT(MOD(xg,REAL(nx)))    !!! Determining the enclosing grid nodes for -x       
    xlow = xup - 1                      !!! Determining the enclosing grid nodes for -x   
    IF(xup.eq.nx) xup=0                 !!! Maximum grid points are the same as the zero ones because of the periodic boundaries condition  
    zx = 1.0+(xg-INT(xg))               !!! Computing the point slopes   
  ELSE
    xlow = INT(MOD(xg,REAL(nx)))        !!! Determining the enclosing grid nodes for +x        
    xup = xlow + 1                      !!! Determining the enclosing grid nodes for +x
    IF(xup.eq.nx) xup=0                 !!! Maximum grid points are the same as the zero ones because of the periodic boundaries condition  
    zx = xg-INT(xg)                     !!! Computing the point slopes 
  END IF
      
  IF(yg < 0.0) THEN
    yup = ny + INT(MOD(yg,REAL(ny)))
    ylow = yup - 1
    IF(yup.eq.ny) yup=0
    zy = 1.0+(yg-INT(yg))      
  ELSE
    ylow = INT(MOD(yg,REAL(ny)))
    yup = ylow + 1
    IF(yup.eq.ny) yup=0
    zy = yg-INT(yg)      
  END IF

  IF(zg < 0.0) THEN
    zup = nz + INT(MOD(zg,REAL(nz)))
    zlow = zup - 1
    IF(zup.eq.nz) zup=0
    zz = 1.0+(zg-INT(zg))
  ELSE
    zlow = INT(MOD(zg,REAL(nz)))
    zup = zlow + 1
    IF(zup.eq.nz) zup=0
    zz = zg-INT(zg)
  END IF

  !!! Finding the real field index on a comutational node in the Z direction (the MPI direction)
  zzup = whereis_z(zup,2) 
  zzlow= whereis_z(zlow,2)  

  !! the point should be identicall to all processors that enter this subroutine!
  up_fpart  = whereis_z(zup,1)
  low_fpart = whereis_z(zlow,1)
  F = 0.0
  !! IF myid is not one of upid or lowid, then my F = 0.0 and I am exiting the subroutine to do other stuff
  IF ((my_fpart.EQ.low_fpart).OR.(my_fpart.EQ.up_fpart)) THEN
    ALLOCATE(Flow(3),  Fup(3))
    Flow = 0.0
    Fup = 0.0
    IF(my_fpart.EQ.low_fpart) THEN
      IF (my_fpart.EQ.up_fpart) THEN
        CALL tra_spline3_Ffull(xlow,ylow,zzlow,xup,yup,zzup,zx,zy,zz,fr1,dfr1,Flow)
      ELSE
        CALL tra_spline3_Flow(xlow,ylow,zzlow,xup,yup,zx,zy,zz,fr1,dfr1,Flow)
        CALL MPI_RECV(Fup,3,MPI_MYREAL,up_fpart,10,MPI_COMM_INSTANCE,status_mpi,ierr)
      END IF
    END IF
    IF ((my_fpart.EQ.up_fpart).AND.(up_fpart.NE.low_fpart)) THEN
      CALL tra_spline3_Fup(xlow,ylow,xup,yup,zzup,zx,zy,zz,fr1,dfr1,Fup)
      CALL MPI_SEND(Fup,3,MPI_MYREAL,low_fpart,10,MPI_COMM_INSTANCE,ierr)
    END IF
    F=Flow+Fup
    DEALLOCATE(Flow, Fup)
  END IF

END SUBROUTINE vtk_interpolate_spline3



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                tra_spline1_Ffull                         !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
SUBROUTINE tra_spline1_Ffull(xlow,ylow,zlow,xup,yup,zup,zx,zy,zz,fr,F)
USE parameters
  IMPLICIT NONE

  REAL, INTENT(IN)                                :: zx, zy, zz                       !! xi eta zeta from the algorithm
  INTEGER, INTENT(IN)                             :: xlow, ylow, zlow, xup, yup, zup  !! Enclosing grid nodes
  REAL, DIMENSION(0:rx,0:ry,0:rz,3),INTENT(IN)    :: fr                               !! Real space field
  REAL, DIMENSION(3), INTENT(OUT)                 :: F                                !! Interpolated field
  
  REAL, DIMENSION(0:1,0:1,0:1,1:3) :: coeff                 !! Temporary coefficients

  coeff(0,0,0,:) = fr(xlow,ylow,zlow,:)
  coeff(1,0,0,:) = fr(xup ,ylow,zlow,:) - coeff(0,0,0,:)
  coeff(0,1,0,:) = fr(xlow,yup ,zlow,:) - coeff(0,0,0,:)
  coeff(0,0,1,:) = fr(xlow,ylow,zup ,:) - coeff(0,0,0,:)
  coeff(1,1,0,:) = fr(xup ,yup ,zlow,:) - fr(xup ,ylow,zlow,:) - coeff(0,1,0,:)
  coeff(1,0,1,:) = fr(xup ,ylow,zup ,:) - fr(xup ,ylow,zlow,:) - coeff(0,0,1,:)
  coeff(0,1,1,:) = fr(xlow,yup ,zup ,:) - fr(xlow,yup ,zlow,:) - coeff(0,0,1,:)
  coeff(1,1,1,:) = fr(xup ,yup ,zup ,:) - fr(xup ,yup ,zlow,:) - fr(xup ,ylow,zup ,:) + fr(xup ,ylow,zlow,:) - coeff(0,1,1,:)
  
  F(:) = coeff(0,0,0,:) + zx*coeff(1,0,0,:) + zy*(coeff(0,1,0,:) + zx*coeff(1,1,0,:)) + zz*(coeff(0,0,1,:) + zx*coeff(1,0,1,:) + zy*(coeff(0,1,1,:) + zx*coeff(1,1,1,:)))
  
END SUBROUTINE tra_spline1_Ffull



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                tra_spline1_Flow                          !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
SUBROUTINE tra_spline1_Flow(xlow,ylow,zlow,xup,yup,zx,zy,zz,fr,Flow)
  USE parameters
  USE mpi_var
  IMPLICIT NONE

  REAL, INTENT(IN)                                :: zx, zy, zz                       !! xi eta zeta from the algorithm
  INTEGER, INTENT(IN)                             :: xlow, ylow, zlow, xup, yup       !! Enclosing grid nodes
  REAL, DIMENSION(0:rx,0:ry,0:rz,3),INTENT(IN)  :: fr                               !! Real space field
  REAL, DIMENSION(3), INTENT(OUT)                 :: Flow                             !! Interpolated field
  
  REAL, DIMENSION(0:1,0:1,0:1,1:3) :: coeff                 !! Temporary coefficients
  coeff(0,0,0,:) = fr(xlow,ylow,zlow,:)
  coeff(1,0,0,:) = fr(xup ,ylow,zlow,:) - coeff(0,0,0,:)
  coeff(0,1,0,:) = fr(xlow,yup ,zlow,:) - coeff(0,0,0,:)
  coeff(0,0,1,:) = - coeff(0,0,0,:)
  coeff(1,1,0,:) = fr(xup ,yup ,zlow,:) - fr(xup ,ylow,zlow,:) - coeff(0,1,0,:)
  coeff(1,0,1,:) = - fr(xup ,ylow,zlow,:) - coeff(0,0,1,:)
  coeff(0,1,1,:) = - fr(xlow,yup ,zlow,:) - coeff(0,0,1,:)
  coeff(1,1,1,:) = - fr(xup ,yup ,zlow,:) + fr(xup ,ylow,zlow,:) - coeff(0,1,1,:)
  
   Flow(:) = coeff(0,0,0,:) + zx*coeff(1,0,0,:) + zy*(coeff(0,1,0,:) + zx*coeff(1,1,0,:)) + zz*(coeff(0,0,1,:) + zx*coeff(1,0,1,:) + zy*(coeff(0,1,1,:) + zx*coeff(1,1,1,:)))
  
END SUBROUTINE tra_spline1_Flow



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                tra_spline1_Fup                           !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
SUBROUTINE tra_spline1_Fup(xlow,ylow,xup,yup,zup,zx,zy,zz,fr,Fup)
  USE parameters
  IMPLICIT NONE

  REAL, INTENT(IN)                                :: zx, zy, zz                       !! xi eta zeta from the algorithm
  INTEGER, INTENT(IN)                             :: xlow, ylow, xup, yup, zup        !! Enclosing grid nodes
  REAL, DIMENSION(0:rx,0:ry,0:rz,3),INTENT(IN)    :: fr                               !! Real space field
  REAL, DIMENSION(3), INTENT(OUT)                 :: Fup                              !! Interpolated field
  
  REAL, DIMENSION(0:1,0:1,0:1,1:3) :: coeff                 !! Temporary coefficients
  
  coeff(0,0,1,:) = fr(xlow,ylow,zup ,:)
  coeff(1,0,1,:) = fr(xup ,ylow,zup ,:) - coeff(0,0,1,:)
  coeff(0,1,1,:) = fr(xlow,yup ,zup ,:) - coeff(0,0,1,:)
  coeff(1,1,1,:) = fr(xup ,yup ,zup ,:) - fr(xup ,ylow,zup ,:) - coeff(0,1,1,:)
  
  Fup(:) = zz*(coeff(0,0,1,:) + zx*coeff(1,0,1,:) + zy*(coeff(0,1,1,:) + zx*coeff(1,1,1,:)))
  
END SUBROUTINE tra_spline1_Fup



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                  tra_spline3_Ffull                       !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE tra_spline3_Ffull(xlow,ylow,zlow,xup,yup,zup,x_normed,y_normed,z_normed,fr,dfr,F)
  USE parameters
  IMPLICIT NONE

  REAL, INTENT(IN)                                :: x_normed, y_normed, z_normed     !! xi eta zeta from the algorithm
  INTEGER, INTENT(IN)                             :: xlow, ylow, zlow, xup, yup, zup  !! Enclosing grid nodes
  REAL, DIMENSION(0:rx,0:ry,0:rz,3),INTENT(IN)  :: fr                               !! Real space field
  REAL, DIMENSION(0:rx,0:ry,0:rz,3,3),INTENT(IN):: dfr                              !! Spatial derivatives of real space field
  REAL, DIMENSION(3), INTENT(OUT)                 :: F                                !! Interpolated field
  
  REAL, DIMENSION(0:1,0:1,0:1,1:3) :: coeff                 !! Temporary coefficients
  REAL                             :: x_normed2, x_normed3
  
    x_normed2=x_normed*x_normed
    x_normed3=x_normed*x_normed2
    
    coeff(0,0,0,:) = fr(xlow,ylow,zlow,:)
    coeff(1,0,0,:) = fr(xup ,ylow,zlow,:) - coeff(0,0,0,:)
    coeff(0,1,0,:) = fr(xlow,yup ,zlow,:) - coeff(0,0,0,:)
    coeff(0,0,1,:) = fr(xlow,ylow,zup ,:) - coeff(0,0,0,:)
    coeff(1,1,0,:) = fr(xup ,yup ,zlow,:) - fr(xup ,ylow,zlow,:) - coeff(0,1,0,:)
    coeff(1,0,1,:) = fr(xup ,ylow,zup ,:) - fr(xup ,ylow,zlow,:) - coeff(0,0,1,:)
    coeff(0,1,1,:) = fr(xlow,yup ,zup ,:) - fr(xlow,yup ,zlow,:) - coeff(0,0,1,:)
    coeff(1,1,1,:) = fr(xup ,yup ,zup ,:) - fr(xup ,yup ,zlow,:) - fr(xup ,ylow,zup ,:) + fr(xup ,ylow,zlow,:) - coeff(0,1,1,:)
    
    F(:) = ((((((dfr(xup,yup,zup,:,3) + dfr(xup,yup,zlow,:,3) - dfr(xup,ylow,zup,:,3) - dfr(xup,ylow,zlow,:,3) - dfr(xlow,yup,zup,:,3) - dfr(xlow,yup,zlow,:,3) + dfr(xlow,ylow,zup,:,3) + dfr(xlow,ylow,zlow,:,3)) * dz - 2*coeff(1,1,1,:)) * x_normed &
    + (dfr(xlow,yup,zup,:,3) + dfr(xlow,yup,zlow,:,3) - dfr(xlow,ylow,zup,:,3) - dfr(xlow,ylow,zlow,:,3)) * dz - 2*coeff(0,1,1,:)) * y_normed &
    + ((dfr(xup,ylow,zup,:,3) + dfr(xup,ylow,zlow,:,3) - dfr(xlow,ylow,zup,:,3) - dfr(xlow,ylow,zlow,:,3)) * dz - 2*coeff(1,0,1,:)) * x_normed &
    + (dfr(xlow,ylow,zup,:,3) + dfr(xlow,ylow,zlow,:,3)) * dz - 2*coeff(0,0,1,:)) * z_normed &
    + (((( - dfr(xup,yup,zup,:,3) + dfr(xup,ylow,zup,:,3) + dfr(xlow,yup,zup,:,3) - dfr(xlow,ylow,zup,:,3) + 2 * (- dfr(xup,yup,zlow,:,3) + dfr(xup,ylow,zlow,:,3) + dfr(xlow,yup,zlow,:,3) - dfr(xlow,ylow,zlow,:,3))) * dz + 3*coeff(1,1,1,:)) * x_normed &
    + ( - dfr(xlow,yup,zup,:,3) + dfr(xlow,ylow,zup,:,3) + 2 * ( - dfr(xlow,yup,zlow,:,3) + dfr(xlow,ylow,zlow,:,3))) * dz + 3*coeff(0,1,1,:)) * y_normed &
    + (( - dfr(xup,ylow,zup,:,3) + dfr(xlow,ylow,zup,:,3) + 2 * (- dfr(xup,ylow,zlow,:,3) + dfr(xlow,ylow,zlow,:,3))) * dz + 3*coeff(1,0,1,:)) * x_normed &
    + ( - dfr(xlow,ylow,zup,:,3) - 2 * dfr(xlow,ylow,zlow,:,3)) * dz + 3*coeff(0,0,1,:))) * z_normed &
    + ((((((dfr(xup,yup,zup,:,2) - dfr(xup,yup,zlow,:,2) + dfr(xup,ylow,zup,:,2) - dfr(xup,ylow,zlow,:,2) - dfr(xlow,yup,zup,:,2) + dfr(xlow,yup,zlow,:,2) - dfr(xlow,ylow,zup,:,2) + dfr(xlow,ylow,zlow,:,2)) * dy - 2*coeff(1,1,1,:)) * x_normed &
    + (dfr(xlow,yup,zup,:,2) - dfr(xlow,yup,zlow,:,2) + dfr(xlow,ylow,zup,:,2) - dfr(xlow,ylow,zlow,:,2)) * dy - 2*coeff(0,1,1,:)) * y_normed &
    + ((( - dfr(xup,yup,zup,:,2) + dfr(xup,yup,zlow,:,2) + dfr(xlow,yup,zup,:,2) - dfr(xlow,yup,zlow,:,2) + 2 * (- dfr(xup,ylow,zup,:,2) + dfr(xup,ylow,zlow,:,2) + dfr(xlow,ylow,zup,:,2) - dfr(xlow,ylow,zlow,:,2))) * dy + 3*coeff(1,1,1,:)) * x_normed &
    + ( - dfr(xlow,yup,zup,:,2) + dfr(xlow,yup,zlow,:,2) + 2 * (- dfr(xlow,ylow,zup,:,2) + dfr(xlow,ylow,zlow,:,2))) * dy + 3*coeff(0,1,1,:))) * y_normed &
    + (((dfr(xup,yup,zup,:,1) - dfr(xup,yup,zlow,:,1) - dfr(xup,ylow,zup,:,1) + dfr(xup,ylow,zlow,:,1) + dfr(xlow,yup,zup,:,1) - dfr(xlow,yup,zlow,:,1) - dfr(xlow,ylow,zup,:,1) + dfr(xlow,ylow,zlow,:,1)) * dx - 2*coeff(1,1,1,:)) * x_normed3 &
    + (( - dfr(xup,yup,zup,:,1) + dfr(xup,yup,zlow,:,1) + dfr(xup,ylow,zup,:,1) - dfr(xup,ylow,zlow,:,1) + 2 * (- dfr(xlow,yup,zup,:,1) + dfr(xlow,yup,zlow,:,1) + dfr(xlow,ylow,zup,:,1) - dfr(xlow,ylow,zlow,:,1))) * dx + 3*coeff(1,1,1,:)) * x_normed2 &
    + ((dfr(xup,yup,zlow,:,3) - dfr(xup,ylow,zlow,:,3) - dfr(xlow,yup,zlow,:,3) + dfr(xlow,ylow,zlow,:,3)) * dz + (dfr(xup,ylow,zup,:,2) - dfr(xup,ylow,zlow,:,2) - dfr(xlow,ylow,zup,:,2) + dfr(xlow,ylow,zlow,:,2)) * dy + (dfr(xlow,yup,zup,:,1) - dfr(xlow,yup,zlow,:,1) - dfr(xlow,ylow,zup,:,1) + dfr(xlow,ylow,zlow,:,1)) * dx - 2 * coeff(1,1,1,:)) * x_normed &
    + (dfr(xlow,yup,zlow,:,3) - dfr(xlow,ylow,zlow,:,3)) * dz + (dfr(xlow,ylow,zup,:,2) - dfr(xlow,ylow,zlow,:,2)) * dy - coeff(0,1,1,:))) * y_normed &
    + ((dfr(xup,ylow,zup,:,1) - dfr(xup,ylow,zlow,:,1) + dfr(xlow,ylow,zup,:,1) - dfr(xlow,ylow,zlow,:,1)) * dx - 2*coeff(1,0,1,:)) * x_normed3 &
    + (( - dfr(xup,ylow,zup,:,1) + dfr(xup,ylow,zlow,:,1) + 2 * (- dfr(xlow,ylow,zup,:,1) + dfr(xlow,ylow,zlow,:,1))) * dx + 3*coeff(1,0,1,:)) * x_normed2 &
    + ((dfr(xup,ylow,zlow,:,3) - dfr(xlow,ylow,zlow,:,3)) * dz + (dfr(xlow,ylow,zup,:,1) - dfr(xlow,ylow,zlow,:,1)) * dx - coeff(1,0,1,:)) * x_normed + dfr(xlow,ylow,zlow,:,3) * dz)) * z_normed &
    + (((((dfr(xup,yup,zlow,:,2) + dfr(xup,ylow,zlow,:,2) - dfr(xlow,yup,zlow,:,2) - dfr(xlow,ylow,zlow,:,2)) * dy - 2*coeff(1,1,0,:)) * x_normed &
    + (dfr(xlow,yup,zlow,:,2) + dfr(xlow,ylow,zlow,:,2)) * dy - 2*coeff(0,1,0,:)) * y_normed &
    + ((( - dfr(xup,yup,zlow,:,2) + dfr(xlow,yup,zlow,:,2) + 2 * (- dfr(xup,ylow,zlow,:,2) + dfr(xlow,ylow,zlow,:,2))) * dy + 3*coeff(1,1,0,:)) * x_normed &
    + ( - dfr(xlow,yup,zlow,:,2) - 2 * dfr(xlow,ylow,zlow,:,2)) * dy + 3*coeff(0,1,0,:))) * y_normed &
    + (((dfr(xup,yup,zlow,:,1) - dfr(xup,ylow,zlow,:,1) + dfr(xlow,yup,zlow,:,1) - dfr(xlow,ylow,zlow,:,1)) * dx - 2*coeff(1,1,0,:)) * x_normed3 &
    + (( - dfr(xup,yup,zlow,:,1) + dfr(xup,ylow,zlow,:,1) + 2 * (- dfr(xlow,yup,zlow,:,1) + dfr(xlow,ylow,zlow,:,1))) * dx + 3*coeff(1,1,0,:)) * x_normed2 &
    + ((dfr(xup,ylow,zlow,:,2) - dfr(xlow,ylow,zlow,:,2)) * dy + (dfr(xlow,yup,zlow,:,1) - dfr(xlow,ylow,zlow,:,1)) * dx - coeff(1,1,0,:)) * x_normed + dfr(xlow,ylow,zlow,:,2) * dy)) * y_normed &
    + ((dfr(xup,ylow,zlow,:,1) + dfr(xlow,ylow,zlow,:,1)) * dx - 2*coeff(1,0,0,:)) * x_normed3 &
    + (( - dfr(xup,ylow,zlow,:,1) - 2 * dfr(xlow,ylow,zlow,:,1)) * dx + 3*coeff(1,0,0,:)) * x_normed2 &
    + dfr(xlow,ylow,zlow,:,1) * dx * x_normed + coeff(0,0,0,:)

END SUBROUTINE tra_spline3_Ffull



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                  tra_spline3_Flow                        !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE tra_spline3_Flow(xlow,ylow,zlow,xup,yup,x_normed,y_normed,z_normed,fr,dfr,Flow)
  USE parameters
  IMPLICIT NONE

  REAL, INTENT(IN)                                :: x_normed, y_normed, z_normed     !! xi eta zeta from the algorithm
  INTEGER, INTENT(IN)                             :: xlow, ylow, zlow, xup, yup  !! Enclosing grid nodes
  REAL, DIMENSION(0:rx,0:ry,0:rz,3),INTENT(IN)  :: fr                               !! Real space field
  REAL, DIMENSION(0:rx,0:ry,0:rz,3,3),INTENT(IN):: dfr                              !! Spatial derivatives of real space field
  REAL, DIMENSION(3), INTENT(OUT)                 :: Flow                             !! Interpolated field
  
  REAL, DIMENSION(0:1,0:1,0:1,1:3) :: coeff                 !! Temporary coefficients
  REAL                             :: x_normed2, x_normed3
  
    x_normed2=x_normed*x_normed
    x_normed3=x_normed*x_normed2
    
    coeff(0,0,0,:) = fr(xlow,ylow,zlow,:)
    coeff(1,0,0,:) = fr(xup ,ylow,zlow,:) - coeff(0,0,0,:)
    coeff(0,1,0,:) = fr(xlow,yup ,zlow,:) - coeff(0,0,0,:)
    coeff(0,0,1,:) = - coeff(0,0,0,:)
    coeff(1,1,0,:) = fr(xup ,yup ,zlow,:) - fr(xup ,ylow,zlow,:) - coeff(0,1,0,:)
    coeff(1,0,1,:) = - fr(xup ,ylow,zlow,:) - coeff(0,0,1,:)
    coeff(0,1,1,:) = - fr(xlow,yup ,zlow,:) - coeff(0,0,1,:)
    coeff(1,1,1,:) = - fr(xup ,yup ,zlow,:) + fr(xup ,ylow,zlow,:) - coeff(0,1,1,:)
    
    Flow(:) = ((((((dfr(xup ,yup ,zlow,:,3) - dfr(xup ,ylow,zlow,:,3) - dfr(xlow,yup ,zlow,:,3) + dfr(xlow,ylow,zlow,:,3)) * dz - 2*coeff(1,1,1,:)) * x_normed &
    + (dfr(xlow,yup ,zlow,:,3) - dfr(xlow,ylow,zlow,:,3)) * dz - 2*coeff(0,1,1,:)) * y_normed &
    + ((dfr(xup ,ylow,zlow,:,3) - dfr(xlow,ylow,zlow,:,3)) * dz - 2*coeff(1,0,1,:)) * x_normed &
    + (dfr(xlow,ylow,zlow,:,3)) * dz - 2*coeff(0,0,1,:)) * z_normed &
    + ((((2 * (- dfr(xup ,yup ,zlow,:,3) + dfr(xup ,ylow,zlow,:,3) + dfr(xlow,yup ,zlow,:,3) - dfr(xlow,ylow,zlow,:,3))) * dz + 3*coeff(1,1,1,:)) * x_normed &
    + (2 * ( - dfr(xlow,yup ,zlow,:,3) + dfr(xlow,ylow,zlow,:,3))) * dz + 3*coeff(0,1,1,:)) * y_normed &
    + ((2 * (- dfr(xup ,ylow,zlow,:,3) + dfr(xlow,ylow,zlow,:,3))) * dz + 3*coeff(1,0,1,:)) * x_normed &
    + ( - 2 * dfr(xlow,ylow,zlow,:,3)) * dz + 3*coeff(0,0,1,:))) * z_normed &
    + ((((((- dfr(xup ,yup ,zlow,:,2) - dfr(xup ,ylow,zlow,:,2) + dfr(xlow,yup ,zlow,:,2) + dfr(xlow,ylow,zlow,:,2)) * dy - 2*coeff(1,1,1,:)) * x_normed &
    + (- dfr(xlow,yup ,zlow,:,2) - dfr(xlow,ylow,zlow,:,2)) * dy - 2*coeff(0,1,1,:)) * y_normed &
    + (((dfr(xup ,yup ,zlow,:,2) - dfr(xlow,yup ,zlow,:,2) + 2 * (+ dfr(xup ,ylow,zlow,:,2) - dfr(xlow,ylow,zlow,:,2))) * dy + 3*coeff(1,1,1,:)) * x_normed &
    + (dfr(xlow,yup ,zlow,:,2) + 2 * (+ dfr(xlow,ylow,zlow,:,2))) * dy + 3*coeff(0,1,1,:))) * y_normed &
    + (((- dfr(xup ,yup ,zlow,:,1) + dfr(xup ,ylow,zlow,:,1) - dfr(xlow,yup ,zlow,:,1) + dfr(xlow,ylow,zlow,:,1)) * dx - 2*coeff(1,1,1,:)) * x_normed3 &
    + ((dfr(xup ,yup ,zlow,:,1) - dfr(xup ,ylow,zlow,:,1) + 2 * (+ dfr(xlow,yup ,zlow,:,1) - dfr(xlow,ylow,zlow,:,1))) * dx + 3*coeff(1,1,1,:)) * x_normed2 &
    + ((dfr(xup ,yup ,zlow,:,3) - dfr(xup ,ylow,zlow,:,3) - dfr(xlow,yup ,zlow,:,3) + dfr(xlow,ylow,zlow,:,3)) * dz + (- dfr(xup ,ylow,zlow,:,2) + dfr(xlow,ylow,zlow,:,2)) * dy + (- dfr(xlow,yup ,zlow,:,1) + dfr(xlow,ylow,zlow,:,1)) * dx - 2 * coeff(1,1,1,:)) * x_normed &
    + (dfr(xlow,yup ,zlow,:,3) - dfr(xlow,ylow,zlow,:,3)) * dz + (- dfr(xlow,ylow,zlow,:,2)) * dy - coeff(0,1,1,:))) * y_normed &
    + ((- dfr(xup ,ylow,zlow,:,1) - dfr(xlow,ylow,zlow,:,1)) * dx - 2*coeff(1,0,1,:)) * x_normed3 &
    + ((dfr(xup ,ylow,zlow,:,1) + 2 * (+ dfr(xlow,ylow,zlow,:,1))) * dx + 3*coeff(1,0,1,:)) * x_normed2 &
    + ((dfr(xup ,ylow,zlow,:,3) - dfr(xlow,ylow,zlow,:,3)) * dz + (- dfr(xlow,ylow,zlow,:,1)) * dx - coeff(1,0,1,:)) * x_normed + dfr(xlow,ylow,zlow,:,3) * dz)) * z_normed &
    + (((((dfr(xup ,yup ,zlow,:,2) + dfr(xup ,ylow,zlow,:,2) - dfr(xlow,yup ,zlow,:,2) - dfr(xlow,ylow,zlow,:,2)) * dy - 2*coeff(1,1,0,:)) * x_normed &
    + (dfr(xlow,yup ,zlow,:,2) + dfr(xlow,ylow,zlow,:,2)) * dy - 2*coeff(0,1,0,:)) * y_normed &
    + ((( - dfr(xup ,yup ,zlow,:,2) + dfr(xlow,yup ,zlow,:,2) + 2 * (- dfr(xup ,ylow,zlow,:,2) + dfr(xlow,ylow,zlow,:,2))) * dy + 3*coeff(1,1,0,:)) * x_normed &
    + (- dfr(xlow,yup ,zlow,:,2) - 2 * dfr(xlow,ylow,zlow,:,2)) * dy + 3*coeff(0,1,0,:))) * y_normed &
    + (((dfr(xup ,yup ,zlow,:,1) - dfr(xup ,ylow,zlow,:,1) + dfr(xlow,yup ,zlow,:,1) - dfr(xlow,ylow,zlow,:,1)) * dx - 2*coeff(1,1,0,:)) * x_normed3 &
    + ((- dfr(xup ,yup ,zlow,:,1) + dfr(xup ,ylow,zlow,:,1) + 2 * (- dfr(xlow,yup ,zlow,:,1) + dfr(xlow,ylow,zlow,:,1))) * dx + 3*coeff(1,1,0,:)) * x_normed2 &
    + ((dfr(xup ,ylow,zlow,:,2) - dfr(xlow,ylow,zlow,:,2)) * dy + (dfr(xlow,yup ,zlow,:,1) - dfr(xlow,ylow,zlow,:,1)) * dx - coeff(1,1,0,:)) * x_normed + dfr(xlow,ylow,zlow,:,2) * dy)) * y_normed &
    + ((dfr(xup ,ylow,zlow,:,1) + dfr(xlow,ylow,zlow,:,1)) * dx - 2*coeff(1,0,0,:)) * x_normed3 &
    + ((- dfr(xup ,ylow,zlow,:,1) - 2 * dfr(xlow,ylow,zlow,:,1)) * dx + 3*coeff(1,0,0,:)) * x_normed2 &
    + dfr(xlow,ylow,zlow,:,1) * dx * x_normed + coeff(0,0,0,:)

END SUBROUTINE tra_spline3_Flow



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                  tra_spline3_Fup                         !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE tra_spline3_Fup(xlow,ylow,xup,yup,zup,x_normed,y_normed,z_normed,fr,dfr,Fup)
  USE parameters
  IMPLICIT NONE

  REAL, INTENT(IN)                                :: x_normed, y_normed, z_normed     !! xi eta zeta from the algorithm
  INTEGER, INTENT(IN)                             :: xlow, ylow, xup, yup, zup        !! Enclosing grid nodes
  REAL, DIMENSION(0:rx,0:ry,0:rz,3),INTENT(IN)  :: fr                               !! Real space field
  REAL, DIMENSION(0:rx,0:ry,0:rz,3,3),INTENT(IN):: dfr                              !! Spatial derivatives of real space field
  REAL, DIMENSION(3), INTENT(OUT)                 :: Fup                             !! Interpolated field
  
  REAL, DIMENSION(0:1,0:1,0:1,1:3) :: coeff                 !! Temporary coefficients
  REAL                             :: x_normed2, x_normed3
  
    x_normed2=x_normed*x_normed
    x_normed3=x_normed*x_normed2
    
    coeff(0,0,1,:) = fr(xlow,ylow,zup ,:)
    coeff(1,0,1,:) = fr(xup ,ylow,zup ,:) - coeff(0,0,1,:)
    coeff(0,1,1,:) = fr(xlow,yup ,zup ,:) - coeff(0,0,1,:)
    coeff(1,1,1,:) = fr(xup ,yup ,zup ,:) - fr(xup ,ylow,zup ,:) - coeff(0,1,1,:)
    
    Fup (:) = ((((((dfr(xup ,yup ,zup ,:,3) - dfr(xup ,ylow,zup ,:,3) - dfr(xlow,yup ,zup ,:,3) + dfr(xlow,ylow,zup ,:,3)) * dz - 2*coeff(1,1,1,:)) * x_normed &
    + (dfr(xlow,yup ,zup ,:,3) - dfr(xlow,ylow,zup ,:,3)) * dz - 2*coeff(0,1,1,:)) * y_normed &
    + ((dfr(xup ,ylow,zup ,:,3) - dfr(xlow,ylow,zup ,:,3)) * dz - 2*coeff(1,0,1,:)) * x_normed &
    + (dfr(xlow,ylow,zup ,:,3)) * dz - 2*coeff(0,0,1,:)) * z_normed &
    + (((( - dfr(xup ,yup ,zup ,:,3) + dfr(xup ,ylow,zup ,:,3) + dfr(xlow,yup ,zup ,:,3) - dfr(xlow,ylow,zup ,:,3)) * dz + 3*coeff(1,1,1,:)) * x_normed &
    + ( - dfr(xlow,yup ,zup ,:,3) + dfr(xlow,ylow,zup ,:,3)) * dz + 3*coeff(0,1,1,:)) * y_normed &
    + (( - dfr(xup ,ylow,zup ,:,3) + dfr(xlow,ylow,zup ,:,3)) * dz + 3*coeff(1,0,1,:)) * x_normed &
    + ( - dfr(xlow,ylow,zup ,:,3)) * dz + 3*coeff(0,0,1,:))) * z_normed &
    + ((((((dfr(xup ,yup ,zup ,:,2) + dfr(xup ,ylow,zup ,:,2) - dfr(xlow,yup ,zup ,:,2) - dfr(xlow,ylow,zup ,:,2)) * dy - 2*coeff(1,1,1,:)) * x_normed &
    + (dfr(xlow,yup ,zup ,:,2) + dfr(xlow,ylow,zup ,:,2)) * dy - 2*coeff(0,1,1,:)) * y_normed &
    + ((( - dfr(xup ,yup ,zup ,:,2) + dfr(xlow,yup ,zup ,:,2) + 2 * (- dfr(xup ,ylow,zup ,:,2) + dfr(xlow,ylow,zup ,:,2))) * dy + 3*coeff(1,1,1,:)) * x_normed &
    + ( - dfr(xlow,yup ,zup ,:,2) + 2 * (- dfr(xlow,ylow,zup ,:,2))) * dy + 3*coeff(0,1,1,:))) * y_normed &
    + (((dfr(xup ,yup ,zup ,:,1) - dfr(xup ,ylow,zup ,:,1) + dfr(xlow,yup ,zup ,:,1) - dfr(xlow,ylow,zup ,:,1)) * dx - 2*coeff(1,1,1,:)) * x_normed3 &
    + (( - dfr(xup ,yup ,zup ,:,1) + dfr(xup ,ylow,zup ,:,1) + 2 * (- dfr(xlow,yup ,zup ,:,1) + dfr(xlow,ylow,zup ,:,1))) * dx + 3*coeff(1,1,1,:)) * x_normed2 &
    + ((dfr(xup ,ylow,zup ,:,2) - dfr(xlow,ylow,zup ,:,2)) * dy + (dfr(xlow,yup ,zup ,:,1) - dfr(xlow,ylow,zup ,:,1)) * dx - 2 * coeff(1,1,1,:)) * x_normed &
    + (dfr(xlow,ylow,zup ,:,2)) * dy - coeff(0,1,1,:))) * y_normed &
    + ((dfr(xup ,ylow,zup ,:,1) + dfr(xlow,ylow,zup ,:,1)) * dx - 2*coeff(1,0,1,:)) * x_normed3 &
    + (( - dfr(xup ,ylow,zup ,:,1) + 2 * (- dfr(xlow,ylow,zup ,:,1))) * dx + 3*coeff(1,0,1,:)) * x_normed2 &
    + ((dfr(xlow,ylow,zup ,:,1)) * dx - coeff(1,0,1,:)) * x_normed)) * z_normed 

END SUBROUTINE tra_spline3_Fup



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                 tra_proc_id                              !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE tra_proc_id(pz, low_fpart, up_fpart) 
  USE parameters
  USE mpi_var
  IMPLICIT NONE
  
  REAL, INTENT(IN)        :: pz
  INTEGER, INTENT(OUT)    :: low_fpart, up_fpart 
  REAL                    :: zg
  INTEGER                 :: zup, zlow

  zg=pz/dz
  IF(zg < 0.0) THEN
    zup = nz + INT(MOD(zg,REAL(nz)))
    zlow = zup - 1
    IF(zup.eq.nz) zup=0
  ELSE
    zlow = INT(MOD(zg,REAL(nz)))
    zup = zlow + 1
    IF(zup.eq.nz) zup=0
  END IF

 low_fpart = whereis_z(zlow,1)
 up_fpart = whereis_z(zup,1)
 
END SUBROUTINE tra_proc_id



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                  transfer_slice_real                     !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE transfer_slice_real(slice,fromid,destination,destid)
  USE parameters
  USE mpi_var
  IMPLICIT NONE

  REAL, DIMENSION(0:rx,0:ry), INTENT(IN)    :: slice
  REAL, DIMENSION(0:rx,0:ry), INTENT(OUT)   :: destination
  INTEGER, INTENT(IN)                       :: fromid, destid

  IF (destid.ne.fromid) THEN
    IF (my_fpart.EQ.fromid) CALL MPI_SEND(slice, (rx+1)*(ry+1), MPI_MYREAL, destid, 10, MPI_COMM_INSTANCE, ierr)
    IF (my_fpart.eq.destid) CALL MPI_RECV(destination, (rx+1)*(ry+1), MPI_MYREAL, fromid, 10, MPI_COMM_INSTANCE, status_mpi, ierr)
  ELSE
    IF (my_fpart.eq.destid) destination=slice
  END IF

END SUBROUTINE transfer_slice_real



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                     compute_curll                        !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE compute_curll(a1, curll)
  USE parameters
  USE variables
  IMPLICIT NONE
 
  COMPLEX, DIMENSION(0:cx,0:cz,0:cy,3), INTENT(IN)   :: a1
  COMPLEX, DIMENSION(0:cx,0:cz,0:cy,3), INTENT(OUT)  :: curll
  INTEGER    :: qx, qy, qz, c

  DO qy=0, cy
    DO qz=0, cz
      DO qx=0, cx
        curll(qx,qz,qy,1)=iky(qy)*a1(qx,qz,qy,3)-ikz(qz)*a1(qx,qz,qy,2)
      END DO
    END DO
  END DO
  DO qy=0, cy
    DO qz=0, cz
      DO qx=0, cx
        curll(qx,qz,qy,2)=ikz(qz)*a1(qx,qz,qy,1)-ikx(qx)*a1(qx,qz,qy,3)
      END DO
    END DO
  END DO
  DO qy=0, cy
    DO qz=0, cz
      DO qx=0, cx
        curll(qx,qz,qy,3)=ikx(qx)*a1(qx,qz,qy,2)-iky(qy)*a1(qx,qz,qy,1)
      END DO
    END DO
  END DO
  
END SUBROUTINE compute_curll



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                          !!
!!                      correl_real                         !!
!!                                                          !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE correl_real(a1, a2, r1)
  USE mpi_var
  USE parameters
  IMPLICIT NONE
  
  COMPLEX, DIMENSION(0:cx,0:cz,0:cy), INTENT(IN)   :: a1,a2
  REAL,    DIMENSION(0:rx,0:ry,0:rz), INTENT(OUT)  :: r1
  COMPLEX, ALLOCATABLE, DIMENSION (:,:,:)          :: c1
  INTEGER         :: qx, qy, qz      

  ALLOCATE(c1(0:cx,0:cz,0:cy))

  DO qy=0,cy
    DO qz=0,cz
      DO qx=0,cx
        c1(qx,qz,qy)=a1(qx,qz,qy)*CONJG(a2(qx,qz,qy))
      END DO
    END DO
  END DO

  CALL ifft3ds(c1,r1)
  r1=r1/(Ck*Ns)
  
  DEALLOCATE(c1)
  
END SUBROUTINE correl_real
