#!/bin/sh

## -----------------------------------------
## Impose to read the script with bash
## -----------------------------------------

#$ -S /bin/bash

##------------------------------------------
## Choose the queue you want to submit your job to:
##  big.q    : for 8 and more processors
##  small.q  : for less than 8 processors
##------------------------------------------

#$ -q big.q

## -----------------------------------------
## Replace NPROC by the desired number of processors
## -----------------------------------------

#$ -pe openmpi 8

## -----------------------------------------
MYDIR=`pwd`
NAME_RUN=turbo
echo "$(echo $NAME_RUN)" > name_run.file

## -----------------------------------------
## Name of the run
## -----------------------------------------

#$ -N z_vtk

## -----------------------------------------
## export the variable MPIR_HOME which needs to be 
## defined in the .bash_profile or .tcshrc.
## -----------------------------------------

MPIR_HOME=/opt/openmpi
#$ -v MPIR_HOME

## -----------------------------------------
## Change directory to this job's working directory
## -----------------------------------------

#$ -cwd

## -----------------------------------------
## Echo  Start time and present Direcory
## -----------------------------------------

echo Start time is `date`
echo Directory is `pwd`

## -----------------------------------------
## Run the executable a.out
## -----------------------------------------

$MPIR_HOME/bin/mpirun -np $NSLOTS ./vtk < name_run.file

## -----------------------------------------
## Echo end time
## -----------------------------------------

echo End time is `date`
