#!/bin/sh

## -----------------------------------------
## Impose to read the script with bash
## -----------------------------------------

#$ -S /bin/bash

##------------------------------------------
## Choose the queue you want to submit your job to:
## dev          : 24 procs (1 hr max)
## le_4_viper   : for jobs that are smaller than 5 processors (so 1,2;3 or 4) without time limit
## 4_8_16_viper : for jobs of 4,8 or 16 procs with a time limit of 20 hr
## 16_32        : 34 procs for parallel computations of 16 or 32 processors (10 hr max)
## 32_64_128    : 128 proc for parallel computations of 32, 64 or 128 processors (10 hr max)
##------------------------------------------

#$ -q 4_8_16_viper

## -----------------------------------------
## Replace NPROC by the desired number of processors
## -----------------------------------------

#$ -pe openmpi 16

## -----------------------------------------
## Name of the run
## -----------------------------------------

#$ -N zzGetspectrum

##------------------------------------------
## Define the local directory, in case it is needed.
##------------------------------------------
MYDIR=`pwd`
NAME_RUN=turbo
echo "$(echo $NAME_RUN)" > name_run.file

## -----------------------------------------
## Change directory to this job's working directory
## -----------------------------------------

#$ -cwd

## -----------------------------------------
## Echo  Start time and present Direcory
## -----------------------------------------

echo Start time is `date`
echo Directory is `pwd`
echo LD_LIBRARY_PATH Directory is $LD_LIBRARY_PATH


## -----------------------------------------
## Run the executable a.out
## -----------------------------------------
 
mpirun -np $NSLOTS ./getspectrum < name_run.file

## -----------------------------------------
## Echo end time
## -----------------------------------------

echo End time is `date`

