#!/bin/bash -l

## -----------------------------------------
## The run time hh:mm:ss
## -----------------------------------------

#PBS -l walltime=23:50:00

## -----------------------------------------
## Replace NPROC by the desired number of processors
## -----------------------------------------

#PBS -l nodes=8:ppn=1
NPROC=8
#PBS -l ncpus=$NPROC

## -----------------------------------------
## Name of the run
## -----------------------------------------

#PBS -N z_spec

## -----------------------------------------
## Other
## -----------------------------------------

#PBS -j oe
#PBS -o output.txt

## -----------------------------------------
## Change directory to this job's working directory
## -----------------------------------------

cd $PBS_0_WORKDIR
cd /data/leuven/300/vsc30019/cross_helicity/MHD_0.2
NAME_RUN=test00
echo "$(echo $NAME_RUN)" > name_run.file

## -----------------------------------------
date
echo "Start..."
mpirun --mca btl openib,sm,self -np $NPROC ./getspectrum < name_run.file
echo "Stop"
date
