#!/bin/bash -l

## -----------------------------------------
## The run time hh:mm:ss
## -----------------------------------------

#PBS -l walltime=23:50:00

## -----------------------------------------
## Replace NPROC by the desired number of processors
## -----------------------------------------

#PBS -l nodes=64:ppn=1
NPROC=64
#PBS -l ncpus=$NPROC

## -----------------------------------------
## Name of the run
## -----------------------------------------

#PBS -N zturbo

## -----------------------------------------
## Other
## -----------------------------------------

#PBS -j oe
#PBS -o output.txt

## -----------------------------------------
## Change directory to this job's working directory
## -----------------------------------------

cd $PBS_0_WORKDIR
cd /data/leuven/300/vsc30019/cross_helicity/MHD_0.2
NAME_RUN=test02
echo "$(echo $NAME_RUN)" > name_run.file

## -----------------------------------------
## Clean the successfully terminated flag
## -----------------------------------------

rm $NAME_RUN.go

## -----------------------------------------
date
echo "Start..."
mpirun --mca btl openib,sm,self -np $NPROC ./turbo < name_run.file

sleep 60
if [ -e $NAME_RUN.go ];then
  /opt/torque/bin/qsub zrun_turbo_512_Vic3.sh
  echo "Relaunch"
fi
 
echo "Stop"
date
